unit cif2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

var
  blocs                   : array[1..10] of string[20];
  nb_blocs                : integer;
  no_ligne_bloc           : array[1..10] of integer;
  nb_ligne_choisi         : integer;

procedure lit_fichier_cif(var ier:integer);

implementation

uses
  mathhkl,groupes, main, quel_bloc2;
type
  tabs                         =  array[1..12] of string[15];
var
  ordre_lecture                  : array[1..10] of integer;
  alire_site                     : array[1..6] of string[25] =
 ('_atom_site_label         ',
  '_atom_site_fract_x       ',
  '_atom_site_fract_y       ',
  '_atom_site_fract_z       ',
  '_atom_site_U_iso_or_equiv',
  '_atom_site_occupancy     ');

  (*
//Extrait jusqu'a 10 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..11] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
end;

procedure decchaine(s: string; var line: vecteur3; var t: double);{
----------------------------------------------------------------
Dcode une sous chaine d'une chaine-position}
var
  i,j,ier,l,k          : integer;

const
  code_pos      : array[1..13] of string =
  ('X-Y','Y-X','-Y+X','-X+Y','-X','-Y', '-Z','+X','+Y','+Z','X','Y','Z');
  ligne         : array[1..39] of double   =
  (1,-1,0,-1,1,0,1,-1,0,-1,1,0,-1,0,0,0,-1,0,0,0,-1,1,0,0,0,1,0,0,0,1
                                                   ,1,0,0,0,1,0,0,0,1);
begin
{suppression des formats fortran}
   i:=pos(' .',s);
   if(i > 0)then s[i]:='0';
   i:=pos('. ',s);
   if(i > 0)then s[i+1]:='0';
{recherche vecteur de position }
   for i:=1 to 13 do begin
     j:=pos(code_pos[i],s);
     if (j > 0) then begin
       k:=(i-1)*3 ;
       line[1]:=ligne[k+1];
       line[2]:=ligne[k+2];
       line[3]:=ligne[k+3];
       l:=length(code_pos[i]);
       delete(s,j,l);
       break;
     end;
   end;
//Translations
   s:=trim(s);
   val(s,t,ier);
end;

procedure decsym(s: string; var r:matrice3; var t:vecteur3); {
-------------------------------------------------------------}
  {Dcodage d'une position, Sparation des 3 sous-chaines, par recherche des
  virgules}
var
  s1,s2,s3                   : string;
  i                          : integer;
  v                          : vecteur3;
begin

  i:=pos(',',s);
  s1:=copy(s,1,i);
  s1[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  i:=pos(',',s);
  s2:=copy(s,1,i);
  s2[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  s3:=s;

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s);

//Dcodage de chaque sous-chaine
  for i:=1 to 3 do begin
    v[i]:=0;
    t[i]:=0;
  end;
  decchaine(s1,v,t[1]);
  for i:=1 to 3 do r[1,i]:=v[i];
  decchaine(s2,v,t[2]);
  for i:=1 to 3 do r[2,i]:=v[i];
  decchaine(s3,v,t[3]);
  for i:=1 to 3 do r[3,i]:=v[i];
end;

procedure dec_val(s:string;var r:vecteur3;var t:double);
//---------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,n,ier  : integer;
  s1       : string;
const
  cxyz : array[1..10] of string[4]=
  ('X','Y','Z','-X','-Y','-Z','X-Y','Y-X','-X+Y','-Y+X');
  vxyz : array [1..30] of double=
  ( 1, 0, 0, 0, 1, 0, 0, 0, 1,-1, 0, 0 ,0,-1, 0, 0, 0,-1,1,-1, 0,-1, 1, 0,
   -1, 1, 0, 1,-1, 0);
  ct   : array[1..15] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6','-1/2',
  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6');
  vt   : array[1..15] of double =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333,-0.5,
  -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333);
begin
  t:=0;
  s:=trim(s);

//Recherche de la translation ==> t
  ier:=1;
  for i:=1 to 15 do begin
    if (pos(ct[i],s) > 0)then begin
      t:=vt[i];
      ier:=0;
      break;
    end;
  end;
  if (t <> 0)then begin
    delete(s,pos(ct[i],s),4);
  end;

//Recherche de la position ==> vecteur r
  for i:=1 to 10 do begin
    s1:=trim(cxyz[i]);
    if (s1 = s)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      exit;
    end;
  end;
  erreur('Cannot decode '+s+' in the file '+extractfilename(nom_fichier_cry));
  halt;

end;
   *)
   //Extrait jusqu'a 10 rels d'une chaine s. no:nb de rels trouvs(==>tableau )



procedure purge_fichier_cif;
//--------------------------
var
  nom1,nom2         : textfile;
  s                 : string;
begin
  AssignFile(nom1,nom_fichier_cry);
  reset(nom1);
  AssignFile(nom2,'dummy.cif');
  rewrite(nom2);
  while not(eof(nom1)) do begin
    readln(nom1,s);
    s:=trim(s);
    if (s = '')then continue;
    writeln(nom2,s);
  end;
  closeFile(nom1);
  closefile(nom2);
end;
   
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..11] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
end;

procedure decchaine(s: string; var line: vecteur3; var t: double);{
----------------------------------------------------------------
Dcode une sous chaine d'une chaine-position}
var
  i,j,ier,l,k          : integer;

const
  code_pos      : array[1..14] of string =
  ('X+Y','X-Y','Y-X','-Y+X','-X+Y','-X','-Y', '-Z','+X','+Y','+Z','X','Y','Z');
  ligne         : array[1..42] of double   =
  (1,1,0,1,-1,0,-1,1,0,1,-1,0,-1,1,0,-1,0,0,0,-1,0,0,0,-1,1,0,0,0,1,0,0,0,1
                                                   ,1,0,0,0,1,0,0,0,1);
begin
{suppression des formats fortran}
   i:=pos(' .',s);
   if(i > 0)then s[i]:='0';
   i:=pos('. ',s);
   if(i > 0)then s[i+1]:='0';
{recherche vecteur de position }
   for i:=1 to 14 do begin
     j:=pos(code_pos[i],s);
     if (j > 0) then begin
       k:=(i-1)*3 ;
       line[1]:=ligne[k+1];
       line[2]:=ligne[k+2];
       line[3]:=ligne[k+3];
       l:=length(code_pos[i]);
       delete(s,j,l);
       break;
     end;
   end;
//Translations
   s:=trim(s);
   val(s,t,ier);
end;

procedure decsym(s: string; var r:matrice3; var t:vecteur3); {
-------------------------------------------------------------}
  {Dcodage d'une position, Sparation des 3 sous-chaines, par recherche des
  virgules}
var
  s1,s2,s3                   : string;
  i                          : integer;
  v                          : vecteur3;
begin

  i:=pos(',',s);
  s1:=copy(s,1,i);
  s1[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  i:=pos(',',s);
  s2:=copy(s,1,i);
  s2[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  s3:=s;

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s);

//Dcodage de chaque sous-chaine
  for i:=1 to 3 do begin
    v[i]:=0;
    t[i]:=0;
  end;
  decchaine(s1,v,t[1]);
  for i:=1 to 3 do r[1,i]:=v[i];
  decchaine(s2,v,t[2]);
  for i:=1 to 3 do r[2,i]:=v[i];
  decchaine(s3,v,t[3]);
  for i:=1 to 3 do r[3,i]:=v[i];
end;

procedure dec_val(s:string;var r:vecteur3;var t:double);
//-----------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,n,ier  : integer;
  s1       : string;
const
  cxyz : array[1..14] of string[4]=
  ('X-Y','Y-X','-X+Y','-Y+X','X+Y',
  'X','Y','Z',
   '+X','+Y','+Z',
  '-X','-Y','-Z');
  vxyz : array [1..42] of double=
   (1,-1, 0,-1, 1, 0, -1, 1, 0, 1,-1, 0,1,1,0,
    1, 0, 0, 0, 1, 0, 0, 0, 1,
    1, 0, 0, 0, 1, 0, 0, 0, 1,
   -1, 0, 0 ,0,-1, 0, 0, 0,-1);
  ct   : array[1..22] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6',
          '-1/2',  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6',
          '1/2', '1/3', '2/3', '1/4', '3/4', '1/6', '5/6');
  vt   : array[1..22] of double =
  ( 0.,0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333,
      -0.5, -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333,
       0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333);
begin
  t:=0;
  s:=trim(s);

//Recherche de la translation ==> t
  ier:=1;
  for i:=1 to 22 do begin
    if (pos(ct[i],s) > 0)then begin
      t:=vt[i];
      ier:=0;
      break;
    end;
  end;
  if (t <> 0)then begin
    delete(s,pos(ct[i],s),length(ct[i]));
  end;
  if (s <> '') and (s[1] = '+')then begin
    delete(s,1,1);
    s:=trim(s);
  end;
//Recherche de la position ==> vecteur r
  for i:=1 to 14 do begin
    s1:=trim(cxyz[i]);
    if (s1 = s)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      exit;
    end;
  end;
  erreur('Cannot decode '+s);
  halt;
end;

{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
begin
  while (pos(' .',s) > 0)do begin
    insert('0',s,pos(' .',s)+1);
  end;
  while (pos(' -.',s) > 0)do begin
    insert('0',s,pos(' -.',s)+2);
  end;
end;

procedure decode_cif_atomes(var s,label_atome:string; var x,y,z,t :double);
//-----------------------------------------------------------------------
var
  ier,i,no                      : integer;
  tableau                       : tab_reel;
  s1                            : string;
begin
  s1:=s;
  verif(s1);
  i:=pos(' ',s1);
  label_atome:=copy(s1,1,i-1);label_atome:=trim(label_atome);
  delete(s1,1,i-1);
  while (pos('(',s1) > 0) do delete(s1,pos('(',s1),pos(')',s1)-pos('(',s1)+1);
  s1:=trim(s1);
  dec(s1,tableau,no,ier);
  x:=tableau[1];
  y:=tableau[2];
  z:=tableau[3];
  t:=tableau[4];
end;

procedure lit_titre;
//------------------
var
  nomf              : textfile;
  s,s1              : string;
  i                 : integer;
  tit               : array[1..5] of string[40];
begin
    AssignFile(nomf,nom_fichier_cry);
    reset(nomf);
    if (nb_ligne_choisi > 0)then for i:=1 to nb_ligne_choisi do readln(nomf);

    titre:='';
    for i:=1 to 5 do tit[i]:='';
    while not(eof(nomf)) do begin
       readln(nomf,s1);
       s1:=trim(s1);
       if (pos('data_',s1) = 1) and (s1 <> 'data_global') then begin
         break;
       end;
       if (s1 = '')then continue;
       if (pos('_chemical_formula_moiety',s1) > 0)   then begin
           if (length(s1) > 24)then s:=trim(copy(s1,25,length(s1)-25+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(nomf,s);
           tit[1]:=trim(s);
       end;
       if (pos('_chemical_formula_structural',s1) > 0)   then begin
           if (length(s1) > 28)then s:=trim(copy(s1,29,length(s1)-29+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(s);
           tit[2]:=trim(s);
       end;
       if (pos('_chemical_formula_analytical',s1) > 0)   then begin
           if (length(s1) > 28)then s:=trim(copy(s1,29,length(s1)-29+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(s);
           tit[3]:=trim(s);
       end;
       if (pos('_chemical_formula_sum',s1) > 0)   then begin
           if (length(s1) > 21)then s:=trim(copy(s1,22,length(s1)-22+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(s);
           tit[4]:=trim(s);
       end;
       if (pos('_chemical_formula_iupac',s1) > 0)   then begin
           if (length(s1) > 23)then s:=trim(copy(s1,24,length(s1)-24+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(s);
           tit[5]:=trim(s);
       end;
     end;
     for i:=1 to 5 do begin
       if (tit[i] = '') or (tit[i] = '?')then continue;
         titre:=tit[i];
//         formule:=titre;
         break;
     end;
     while (pos('''',titre) > 0) do titre[pos('''',titre)]:=' ';
     while (pos(';',titre) > 0)  do titre[pos(';',titre)]:=' ';
     while (pos('"',titre) > 0)  do titre[pos('"',titre)]:=' ';

     closefile(nomf);
     while (pos(' ',titre) > 0) do delete(titre,pos(' ',titre),1);
end;

procedure lit_maille(var ier:integer);
//------------------------------------
var
 nomf                           : textfile;
 s,s1                           : string;
 i,j                            : integer;
 label 1;
begin
//Lecture de la maille
    ier:=0;

    AssignFile(nomf,nom_fichier_cry);
    reset(nomf);
    if (nb_ligne_choisi > 0)then for i:=1 to nb_ligne_choisi do readln(nomf);

    while not(eof(nomf)) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('data_',s) = 1) and (s <> 'data_global') then break;
      s1:='_cell_length_a';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[1],ier);
      end;

      s1:='_cell_length_b';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[2],ier);
      end;

      s1:='_cell_length_c';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[3],ier);
      end;

      s1:='_cell_angle_alpha';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[4]:=90 else val(s,cel[4],ier);
      end;

      s1:='_cell_angle_beta';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //si le sigma est prsent !!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[5]:=90 else val(s,cel[5],ier);
      end;

      s1:='_cell_angle_gamma';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //si le sigma est prsent !!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[6]:=90 else val(s,cel[6],ier);
        break;
      end;
    end;
    closefile(nomf);
end;

Procedure lit_symetries(var ier:integer);
//--------------------------------------
var
 nomf                           : textfile;
 s,s1                           : string;
 i,j                            : integer;
 r                              : vecteur3;
 t                              : double;
 numerotation                   : boolean;
 label 1;
begin
//Recherche des symtries;
    ier:=0;

    AssignFile(nomf,nom_fichier_cry);
    reset(nomf);
    if (nb_ligne_choisi > 0) then for i:=1 to nb_ligne_choisi do readln(nomf);

    npos:=0;
    numerotation:=false;
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('data_',s) = 1)and (s <> 'data_global') then break;
      if (pos('_symmetry_equiv_pos_as_xyz',s) = 0)then continue
      else begin
        npos:=1;
        readln(nomf,s);
        s:=uppercase(s);
        s:=trim(s);

//Correction du 19/03/03 pour tenir compte de la prsence du caractre de tabulation
        s1:=chr(9);
        j:= pos(s1,s);
        if (j > 0)then begin
          delete (s,j,1);
          insert(' ',s,j);
        end;

        s1:=copy(s,1,2);
        if (s1 = '1 ')then begin
           numerotation:=true;
        end;
//Correction du 23 mai 2001:les positions sont numerotes!
        if (numerotation = true)then s:=copy(s,pos(' ',s),length(s)-pos(' ',s)+1);
        s:=trim(s);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
        if (pos(' ',s) > 0)then while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
        s_pos[npos]:=s;
        repeat
          readln(nomf,s);
          s:=trim(s); s:=uppercase(s);

//Correction du 19/03/03 pour tenir compte de la prsence du caractre de tabulation
          if (j > 0)then begin
            delete (s,j,1);
            insert(' ',s,j);
          end;

          if (pos('_',s) > 0) or (trim(s) = '') then break;
          npos:=npos+1;
//Correction du 23 mai 2001:les positions sont numerotes!
          if (numerotation = true)then s:=copy(s,pos(' ',s),length(s)-pos(' ',s)+1);
          s:=trim(s);
          while (pos('''',s) > 0)do delete(s,pos('''',s),1);
          if (pos(' ',s) > 0)then while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
          s_pos[npos]:=s;
        until (pos('_',s) > 0);
        for i:=1 to npos do begin
          s:=s_pos[i];
          s:=ansiuppercase(s);
          //x
          j:=pos(',',s);
          s1:=copy(s,1,j-1);
          delete(s,1,j);
          dec_val(s1,r,t);
          for j:=1 to 3 do tp[i,1,j]:=r[j];
          tp[i,1,4]:=t;
          //Y
          j:=pos(',',s);
          s1:=copy(s,1,j-1);
          delete(s,1,j);
          dec_val(s1,r,t);
          for j:=1 to 3 do tp[i,2,j]:=r[j];
          tp[i,2,4]:=t;
          //Z
          dec_val(s,r,t);
          for j:=1 to 3 do tp[i,3,j]:=r[j];
          tp[i,3,4]:=t;
        end;
      break;
      end;
    end;
    closefile(nomf);

//Recherche du groupe d'espace
    AssignFile(nomf,nom_fichier_cry);
    reset(nomf);
    if (nb_ligne_choisi > 0) then for i:=1 to nb_ligne_choisi do readln(nomf);

    groupe_espace:='';
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('data_',s) = 1)and (s <> 'data_global')then break;
      
//Hermann-Mauguin
      if (pos('_symmetry_space_group_name_H-M',s) > 0)then begin
        i:=pos(' ',s);
        s:=copy(s,i,length(s)-i+1);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
        while (pos('(',s) > 0)do delete(s,pos('(',s),1);
        while (pos(')',s) > 0)do delete(s,pos(')',s),1);
        while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
        groupe_espace:=trim(s);
        break;
      end;
//Hall
      if (pos('_symmetry_space_group_name_Hall',s) > 0)then begin
        i:=pos(' ',s);
        s:=copy(s,i,length(s)-i+1);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
//      while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
        s:=uppercase(s);
        groupe_espace:=trim(s);
        break;
      end;
    end;
    groupe_espace:=uppercase(groupe_espace);
    closefile(nomf);

    if (groupe_espace = '')then begin
      erreur('Poudrix cannot find the Space group');
      ier:=1;
      exit;
    end;
end;

procedure decompose(s:string; var tab:tabs);
//-----------------------------------------
var
  i,n,l        : integer;
begin
  verif(s);
  for i:=1 to 12 do tab[i]:='';
  s:=trim(s);
  l:=length(s);
  n:=0;
  while (l > 0) do begin
    i:=pos(' ',s);
    if (i > 0)then begin
      n:=n+1;
      tab[n]:=copy(s,1,i-1);
      delete(s,1,i);
      s:=trim(s);
    end else begin
      n:=n+1;
      tab[n]:=trim(s);
      break;
    end;
    l:=length(s);
  end;
  for i:=1 to n do begin
    s:=trim(tab[i]);
    while (pos('(',s) > 0) do delete(s,pos('(',s),pos(')',s)-pos('(',s)+1);
    tab[i]:=s;
  end;
end;

procedure compte_string(var s:string; var n:integer);
//--------------------------------------------------
var
  i,l        : integer;
  s1         : string;
begin
  s1:=s;
  l:=length(s1);
  n:=1;
  while (l > 0) do begin
    i:=pos(' ',s1);
    if (i > 0)then begin
      n:=n+1;
      delete(s1,1,i);
      s1:=trim(s1);
    end else break;
    l:=length(s1);
  end;
end;

procedure fraction(s: string; var x:double);
//----------------------------------------
var
  s1,s2  : string;
  x1,x2  : double;
  ier,i  : integer;
begin
  x:=0;
  if (pos('/',s) > 0)then begin
    i:=pos('/',s);
    s1:=trim(copy(s,1,i-1));
    s2:=trim(copy(s,i+1,length(s)-i));
    val(s1,x1,ier);
    val(s2,x2,ier);
    x:=x1/x2;
  end;
end;

Procedure traite_nom_element(var s:string);
//----------------------------------------
var
  c          : char;
begin
  if (length(s) < 2)then exit;
  c:=s[2];
  if (ord(c) > 47) and (ord(c) < 58)then insert(' ',s,2);
end;

procedure lit_fichier_cif(var ier:integer);
//--------------------------------------
var
 nomf                           : textfile;
 s,s1,atome_label,ligne,nom_old : string;
 i,j,k,no,n,nb_aniso            : integer;
 x,y,z,t,huipi2                 : double;
 tableau                        : tab_reel;

 site,uij                       : array[1..15]of string[30];
 nb_site,nb_uij                 : integer;
 chaines                        : tabs;
 c                              : char;

 sender                         : tobject;

 label 1;

begin

      purge_fichier_cif;
      nom_old:=nom_fichier_cry;
      nom_fichier_cry:='dummy.cif';

   ier:=0;
   huipi2:=8*pi*pi;

//Fichier d'criture
   ier:=0;
   lit_titre;
   lit_maille(ier);
   lit_symetries(ier);
   if (ier > 0)then exit;

//Lecture des atomes

    AssignFile(nomf,nom_fichier_cry);
    reset(nomf);
    if (nb_ligne_choisi > 0) then for i:=1 to nb_ligne_choisi do readln(nomf);

    i:=0;
    nb_atome:=0;

//Recherche de la premire carte _atom_site
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('data_',s) = 1)and (s <> 'data_global')then break;
      if (pos('loop_',s) = 0) then continue;
      readln(nomf,s);
      if (pos('_atom_site_',s) = 0) then continue;
      site[1]:=trim(s);

//Dtection de l'ordre de lecture
      nb_site:=1;
      repeat
        readln(nomf,s);
        s:=trim(s);
        if (pos('_atom_site_',s) > 0) then begin
          nb_site:=nb_site+1;
          site[nb_site]:=trim(s);
        end;
      until (pos('_atom_site_',s) = 0);     //Premier atome
      ligne:=trim(s);

//Ligne incomplete
      compte_string(ligne,n);
       while (n < nb_site) do begin
         readln(nomf,s);
         ligne:=ligne+' '+trim(s);
         compte_string(ligne,n);
       end;

       for i:=1 to 6 do begin
        s:=trim(alire_site[i]);
        for j:=1 to nb_site do begin
          s1:=site[j];
          if (s = s1)then begin
            ordre_lecture[i]:=j;
            break;
          end;
        end;
      end;

      s:='';
      for i:=1 to 6 do begin
        str(ordre_lecture[i]:4,s1);
        s:=s+s1;
      end;

      ier:=0;
      s:=ligne;
      i:=0;
     repeat
         decompose(s,chaines);
         i:=i+1;
//Label
         s1:=chaines[ordre_lecture[1]];
         traite_nom_element(s1);
         s1:=uppercase(s1);
         atome[i]:=copy(s1,1,2);
         labell[i]:=copy(s1,3,length(s1)-2);

//X
         s1:=chaines[ordre_lecture[2]];
         if (pos('/',s1) = 0)then val(s1,x,j) else fraction(s1,x);
         x_at[i]:=x;
//Y
         s1:=chaines[ordre_lecture[3]];
         if (pos('/',s1) = 0)then val(s1,y,j) else fraction(s1,y);
         y_at[i]:=y;
//Z
         s1:=chaines[ordre_lecture[4]];
         if (pos('/',s1) = 0)then val(s1,z,j) else fraction(s1,z);
         z_at[i]:=z;

//B equivalent
         if (ordre_lecture[5] > 0)then begin
           s1:=chaines[ordre_lecture[5]];
           val(s1,t,j);
           btherm[i]:=huipi2*t;
         end else btherm[i]:=1;

//Taux d'occupation
         if (ordre_lecture[6] > 0)then begin
           s1:=chaines[ordre_lecture[6]];
           val(s1,t,j);
           pop[i]:=t;
         end else pop[i]:=1;

         readln(nomf,s);
         if (s  = '') or (s = 'loop_') or (s= '#END') then goto 1 ;

//Ligne incomplete
         compte_string(s,n);
         while (n < nb_site) do begin
           readln(nomf,s1);
           s:=s+' '+trim(s1);
           compte_string(s,n);
         end;
         s:=trim(s);
         if (s = '') or (pos('_',s) > 0) or eof(nomf) or (s[1] = '#') then goto 1
      until (s = '') or (pos('_',s) > 0) ;

    end;
1:  nb_atome:=i;
    closefile(nomf);

//Echec
    if (nb_atome = 0)then begin
      ier:=1;
      erreur('No atom site found');
      exit;
    end;
//-----------------------------------------------------------------------------
    set_elements;
    quel_systeme;
    ecrit_StringGrid1;
    with fmain.listbox2 do begin
        if(systeme = 'CUBI')then ItemIndex:=0;
        if(systeme = 'TETR')then ItemIndex:=1;
        if(systeme = 'ORTH')then ItemIndex:=2;
        if(systeme = 'HEXA')then ItemIndex:=3;
        if(systeme = 'RHOM')then ItemIndex:=4;
        if(systeme = 'MONO')then ItemIndex:=5;
        if(systeme = 'TRIC')then ItemIndex:=6;
        fgroupes.init(Sender);
        if (groupe_espace <> '') then begin
          if (mode = 'HM') then fgroupes.selecte_groupe_HM(Sender)
          else fgroupes.selecte_groupe_getspec(Sender);
        end;
    end;

    ecrit_stringgrid2;
    ecrit_maille;
end;

end.
