unit lilambda;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  Tflilambda = class(TForm)
    Panel14: TPanel;
    Label45: TLabel;
    Label61: TLabel;
    Label64: TLabel;
    Label66: TLabel;
    Label44: TLabel;
    BitBtn8: TBitBtn;
    Edit51: TEdit;
    Edit54: TEdit;
    Edit57: TEdit;
    ListBox3: TListBox;
    procedure lit_lambda(Sender: TObject);
    procedure clicklistbox(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  flilambda: Tflilambda;
  dif_raw  : integer;

implementation

{$R *.DFM}
uses
  mathhkl,fichiers,plecran;

procedure Tflilambda.lit_lambda(Sender: TObject);
//-------------------------------------------
var
  ier                                      : integer;
  x                                        : double;
  s                                        :string;
//numero_anode                             : integer;
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of double = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of double = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of double = (0.71070,1.54180,1.79020,1.93604,2.29090);
begin
      liraw_rietveld(ier);
      if (ier = 1)then begin
        erreur('Read error in the Rietveld file!');
        flilambda.visible:=false;
        exit;
      end;
      s:=edit57.text;
      val(s,x,ier);
      if (ier > 0)then begin
        erreur('Lambda error!');
        exit;
      end;
      lambda_raw:=x;
      s:=edit51.text;
      if (s ='')then s:='0';
      val(s,lambda1_raw,ier);
      if (ier > 0)then begin
        erreur('Lambda1 error!');
        exit;
      end;
      s:=edit54.text;
      val(s,lambda2_raw,ier);
      if (s ='')then s:='0';
      if (ier > 0)then begin
        erreur('Lambda2 error!');
        exit;
      end;
      ratio_raw:=0.50;
      if (listbox3.itemindex = -1)then begin
        lambda1_raw:=0;
        lambda2_raw:=0;
        anode_raw:='?';
        ratio_raw:=1;
      end;
      flilambda.visible:=false;
      lit_fichier_raw2;
      fplecran.dessine(sender);
end;

procedure Tflilambda.clicklistbox(Sender: TObject);
//---------------------------------------------
var
  i                      : integer;
  s                      : string;
//l1,l2                  : double;
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of double = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of double = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of double = (0.71070,1.54180,1.79020,1.93604,2.29090);
begin
      i:=Listbox3.ItemIndex+1;
      anode_raw:=type_anode[i];
      lambda1_raw:=wl1[i];
      lambda2_raw:=wl2[i];
      lambda_raw:=wl[i];
      str(lambda1_raw:8:5,s);
      edit51.text:=s;
      str(lambda2_raw:8:5,s);
      edit54.text:=s;
      str(lambda_raw:8:5,s);
      edit57.text:=s;
      anode_raw:=type_anode[i];
end;

end.
