unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, math, Grids, printers, FileCtrl, ComCtrls,
  MPlayer, Buttons, ColorBtns;

type
  Tfmain = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    Impression1: TMenuItem;
    raz1: TMenuItem;
    aide1: TMenuItem;
    Panel3: TPanel;
    Rsultats1: TMenuItem;
    Panel5: TPanel;
    Label15: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    edit7: TEdit;
    StringGrid1: TStringGrid;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit25: TEdit;
    Edit29: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ListBox2: TListBox;
    Label14: TLabel;
    Label17: TLabel;
    Gnral1: TMenuItem;
    Apropos: TMenuItem;
    ListBox3: TListBox;
    Editionrsultatscondenss1: TMenuItem;
    Coordonnes1: TMenuItem;
    Rsultats2: TMenuItem;
    FichierCRY1: TMenuItem;
    Enregistrement1: TMenuItem;
    StringGrid2: TStringGrid;
    Label18: TLabel;
    Quitter2: TMenuItem;
    Quit1: TMenuItem;
    Diffusionanomale1: TMenuItem;
    Panel2: TPanel;
    RadioGroup2: TRadioGroup;
    Label1: TLabel;
    N2: TMenuItem;
    StringGrid4: TStringGrid;
    N4: TMenuItem;
    N6: TMenuItem;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    RadioGroup1: TRadioGroup;
    PoudriXformatcry1: TMenuItem;
    ShelX93formatout1: TMenuItem;
    ICSDformatics1: TMenuItem;
    Pulvrixformat1: TMenuItem;
    PowderCellformat1: TMenuItem;
    N1: TMenuItem;
    ListBox4: TListBox;
    Label6: TLabel;
    Edit1: TEdit;
    Color95Button4: TColor95Button;
    Color95Button1: TColor95Button;
    Color95Button2: TColor95Button;
    BitBtn4: TBitBtn;
    Label7: TLabel;
    Label8: TLabel;
    Label13: TLabel;
    Label16: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit12: TEdit;
    CIF1: TMenuItem;
    procedure Sortie(Sender: TObject);
    procedure reset_donnees(Sender: TObject);
    procedure lecture_donnees(Sender: TObject);
    procedure rase_resultats(Sender: TObject);
    procedure sauve_donnees(Sender: TObject);
    procedure init_creation(Sender: TObject);
    procedure aide(Sender: TObject);
    procedure lit_fichier_cry(Sender: TObject);
    procedure recalcule(Sender: TObject);
    procedure maj_to_minX(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure edit_resultats(Sender: TObject);
    procedure efface_raw(Sender: TObject);
    procedure rase_general(Sender: TObject);
    procedure ecrit(Sender: TObject);
    procedure efface_spectre(Sender: TObject);
    procedure about(Sender: TObject);
    procedure edition_fstr_out(Sender: TObject);
    procedure rase_coordonnees(Sender: TObject);
    procedure acces_panel5(Sender: TObject);
    procedure sortie_groupe(Sender: TObject);
    procedure rase_dif_ano(Sender: TObject);
    procedure Choix_lp(Sender: TObject);
    procedure Acquisition_f_ano(Sender: TObject);
    procedure bouton_lecture_ano(Sender: TObject);
    procedure optionX(Sender: TObject);
    procedure choixN(Sender: TObject);
    procedure numero_case(Sender: TObject);
    procedure verif_frappe_edit(Sender: TObject);
    procedure maj_to_minN(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure reset_spectre_res(Sender: TObject);
    procedure change_theta_2theta(Sender: TObject);
    procedure lit_fichier_shelx(Sender: TObject);
    procedure powdercell_format(Sender: TObject);
    procedure icsd_format(Sender: TObject);
    procedure pulverix_format(Sender: TObject);
    procedure set_lambda(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure peint_stinggrid1(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure peint_stringgrid4(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure peint_stringgrid2(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure cancel_panel2(Sender: TObject);
    procedure entree_lambda(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure cif_format(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

procedure ecrit_listbox3;
procedure disp_experiment;
procedure ecrit_stringGrid2;
procedure ecrit_stringGrid1;
procedure set_elements;
procedure ecrit_maille;

var
  fmain: Tfmain;

implementation


{$R *.DFM}
uses
  mathhkl, print, apropos, facstruc, fstruc, lp, echelle, plecran, impur,groupes,
  cif2,quel_bloc2,quel_bloc;

  type
  tab_int12                 = array[1..12] of smallint;
  tab_real8                 = array[1..8]  of single;
  tab_real48                = array[1..48] of single;
  tab_car                   = array[1..128]of char;

var
   nb_groupes,no_case                       : integer;
   type_fichier_cry                         : integer;
   no_ligne,numero_bouton                   : integer;

{$i lecture.pas}
{$i controle.pas}

{******************************Gestion des vnements***********************}
{Evnement OnCreate Fmain}
procedure Tfmain.init_creation(Sender: TObject);{
-------------------------------------------------}
var
   s  : string;
   //ier: integer;
begin
   height:=459;
   Color95Button2.font.color:=clred;
   nb_fichier_raw:=0;
   bitbtn3.font.color:=clgray;
   panel2.color:=$FFE4BD;
   radiogroup2.color:=$FFE4BD;
   stringgrid1.visible:=true;
   stringgrid2.visible:=true;
   stringGrid4.visible:=false;
   label18.visible:=true;
   stringgrid4.top:=stringgrid1.top;
   stringgrid4.left:=stringgrid1.left;
   type_source:=1;

   probabilite:=0.5;
   s:='';
   if (fileExists('spgr2.dat') = false) then s:='File spgr2.dat not found';
   if (fileExists('brcow.an')  = false) then s:='File Brcow.an not found';
   if (fileExists('Sasaki.an') = false) then s:='File Sasaki.an not found';
   if (fileExists('csp.lst')   = false) then s:='File Csp.lst not found';
   if (s <> '')then begin
     beep;
     erreur(s);
     halt;
     exit;
   end;

   if (fileExists('fstr2.out') = true) then DeleteFile('fstr2.out');
   if (fileExists('fstr.out') = true) then DeleteFile('fstr.out');

   type_LP:=0;
   type_echelle:=0;
   modif_donnees:=false;
   left:=0;
   top:=0;
   rhom_hexa:=0;
   StringGrid1.colwidths[0]:=27;
   StringGrid1.colwidths[1]:=27;
   StringGrid1.colwidths[5]:=35;
   StringGrid1.colwidths[6]:=35;
   StringGrid1.cells[0,0]:='Atom';
   StringGrid1.cells[1,0]:='Lab.';
   StringGrid1.cells[2,0]:='X';
   StringGrid1.cells[3,0]:='Y';
   StringGrid1.cells[4,0]:='Z';
   StringGrid1.cells[5,0]:='B';
   StringGrid1.cells[6,0]:='Pop';

   StringGrid4.colwidths[0]:=37;
   StringGrid4.colwidths[1]:=27;
   StringGrid4.colwidths[5]:=35;
   StringGrid4.colwidths[6]:=35;
   StringGrid4.cells[0,0]:='Atom';
   StringGrid4.cells[1,0]:='Lab.';
   StringGrid4.cells[2,0]:='X';
   StringGrid4.cells[3,0]:='Y';
   StringGrid4.cells[4,0]:='Z';
   StringGrid4.cells[5,0]:='B';
   StringGrid4.cells[6,0]:='Pop';
   StringGrid4.cells[7,0]:='B Fermi';
   StringGrid2.colwidths[0]:=30;
   GetDir(0,repertoire_origine);
   {constantes manip}
   theta_min:=10;
   theta_max:=50;
   theta_min_depart:=10;
   theta_max_depart:=50;
   edit14.text:='10';
   edit17.text:='50';
   lambda:=0;
   lambda_min:=0;
   lambda_max:=0;
   edit11.text:='';
   u:=0.001;
   v:=0;
   w:=0.005;
   edit19.text:='0.001';
   edit21.text:='0';
   edit25.text:='0.005';
   RadioGroup1.ItemIndex:=1;
   listbox4.itemindex:=-1;

   groupe_espace:='';

end;

{****************************Gestion du menu***********************************}
{Option menu: Sortie}
procedure Tfmain.Sortie(Sender: TObject);{
---------------------------------------------}
begin
  close;
end;

{Option menu: Fichier/Enregistrement}
procedure Tfmain.sauve_donnees(Sender: TObject); {
-------------------------------------------------}
var
   nomf              : TextFile;
   i,j,k             : integer;
   s                 : string;
   wo                : word;
begin
   lit_donnees;
   if (cel[1]*cel[2]*cel[3]*cel[4]*cel[5]*cel[6] = 0)
   or (groupe_espace= '') or (nb_atome = 0) then begin
     beep;
     erreur('Incomplete Data!');
     exit;
   end;
   //chdir(repertoire_donnees);
   SaveDialog1.filterIndex:=1;
   if SaveDialog1.execute then nom_fichier_cry:=SaveDialog1.filename;
   if (length(nom_fichier_cry) > 0) then begin
     nom_fichier_cry:=extractFileName(nom_fichier_cry);
     i:= pos('.cry',nom_fichier_cry);
     if (i = 0) then nom_fichier_cry:=nom_fichier_cry+'.cry';

     if FileExists(nom_fichier_cry) then begin
        beep;
        wo:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (wo = mrNo) or (wo = mrAbort) then exit;
     end;

     panel4.caption:='Data'+' ('+extractFileName(nom_fichier_cry)+')';
     AssignFile(nomf,nom_fichier_cry);
     rewrite(nomf);
     Writeln(nomf,titre);
     writeln(nomf,systeme);
     writeln(nomf,groupe_espace);
     writeln(nomf,cel[1]:9:4,cel[2]:9:4,cel[3]:9:4,
     cel[4]:8:3,cel[5]:8:3,cel[6]:8:3);
     for i:=1 to nb_atome do begin
       //ecriture atome
       s:=atome[i];
       k:=length(s);
       write(nomf,s);
       if (k < 4) then begin
         for j:=k+1 to 4 do write(nomf,' ');
       end ;
       //ecriture label
       s:=labell[i];
       if (length(s) = 0)then write(nomf,'  ');
       if (length(s) = 1)then write(nomf,s[1],' ');
       if (length(s) = 2)then write(nomf,s);
       writeln
       (nomf,' ',x_at[i]:10:6,y_at[i]:10:6,z_at[i]:10:6,btherm[i]:9:3,pop[i]:9:4);
     end;
     closeFile(nomf);
     chdir(repertoire_origine);
     implemente_fichier_cry;
   end;
end;

{Option menu Aide}
procedure Tfmain.aide(Sender: TObject);{
---------------------------------------}
begin
   chdir(repertoire_origine);
   Application.HelpFile:='poudrix.hlp';
   Application.HelpContext(14);
end;

procedure resultats;{
--------------------}
var
  i                                       : integer;
  x                                       : single;
  fmelange,theta_milieu,largeur,intensite : double;
  ymax,y_norm                             : double;
  wl                                      : double;

begin
  fmelange:=0.5;
  pas:=(theta_max-theta_min)/1014;
  for i:=1 to 1015 do y_pro[i]:=0;

  if (fmain.radiogroup1.itemIndex = 2) then begin
    //Representation en Q
    for i:=1 to nb_raie_tot do begin
      theta_milieu:=raies_tot[i].dtheta ;
      x:=tan(theta_milieu/114.5914);
      largeur:=u*x*x+v*x+w;
      if (largeur < 0)then begin
        erreur('Bad u,v,w values (angular width < 0!)');
        exit;
      end;
      largeur:=sqrt(largeur);
      intensite:=raies_tot[i].int;
      wl:=raies_tot[i].wl;
//-----------------------------
      if (fgroupes.ListBox3.itemIndex = -1) and (systeme = 'MONO')
      and (abs(cel[6]-90) > 0.1)then begin
        erreur ('The unique axis cannot be parallel to C axis!');
        exit;
      end;
      calc_profil(fmelange,wl,theta_milieu,largeur,intensite/10);
//-----------------------------
    end;
  end else begin
//reprsentation en 2Thta ou Thta
    for i:=1 to nb_raie_tot do begin
      theta_milieu:=raies_tot[i].dtheta;
      x:=tan(theta_milieu/114.5914);
      largeur:=u*x*x+v*x+w;
      if (largeur < 0)then begin
        erreur('Bad u,v,w values (angular width < 0!)');
        exit;
      end;
      largeur:=sqrt(largeur);
      intensite:=raies_tot[i].int;
      wl:=lambda_calc;
//-----------------------------
      calc_profil(fmelange,wl,theta_milieu,largeur,intensite/10);
//-----------------------------
    end;
  end;
  ymax:=0;
  for i:=1 to 1015 do  if(y_pro[i] > ymax)then ymax:=y_pro[i];
  y_norm:=100/ymax;
  for i:=1 to 1015 do y_pro[i]:=y_pro[i]*y_norm;
  nb_pro:=1015;
//-----------------------------
  ecrit_listbox3;
//-----------------------------
end;

{Evnement OnClick de ListBox1: groupe d'espace. Dclenche la lecture des donnes
et le calcul du spectre}
procedure Tfmain.recalcule(Sender: TObject);{
--------------------------------------------}
var
  ier,i,j                   : integer;
  //s                         : string[50];
  raie_dummy                : reflection;
begin
  theta_min_depart:=theta_min;
  theta_max_depart:=theta_max;
  if (length(nom_fichier_raw) > 0) then recalcule_echelle_raw;

//---------------------------------------------------------------
  verif_donnees(ier);
//---------------------------------------------------------------

  if (ier = 1)then exit;

//calcul du diagramme;
  screen.cursor:=crHourGlass;
  chdir(repertoire_origine);

  nb_raie_tot:=0;
  assignFile(nom_fic1,'fstr2.out');
  rewrite(nom_fic1);
  assignFile(nom_fic2,'fstr.out');
  rewrite(nom_fic2);

   for i:=1 to 1000 do q_tot[i].int:=0;
//Lambda unique
  if (nb_wl_impur = 0)then begin
    if (lambda = 0) then begin
      erreur('Lambda not defined!');
      screen.cursor:=crDefault;
      closefile(nom_fic1);
      closefile(nom_fic2);
      exit;
    end;
    nb_tour:=1;
    lambda_calc:=lambda;
    nb_wl_impur:=1;
    wl_impur[1]:=lambda;
    lambda_max:=lambda;
    lambda_min:=lambda;
    pcent_impur[1]:=1;
  end;
//Lambda multiple
  nb_tour:=0;
  qint_max:=0;
  for i:=1 to nb_wl_impur do begin
      lambda_calc:=wl_impur[i];
      nb_tour:=nb_tour+1;

//---------------------------------------------------------------
      calcul_diagramme(ier);
//---------------------------------------------------------------

      for i:=1 to nb_raie do begin
        q_tot[i].h:=raies_part[i].h;
        q_tot[i].k:=raies_part[i].k;
        q_tot[i].l:=raies_part[i].l;
        q_tot[i].q:=2*pi/raies_part[i].dhkl;
        q_tot[i].int:=q_tot[i].int+raies_part[i].int;
        if (q_tot[i].int > qint_max)then qint_max:=q_tot[i].int ;
      end;
      if (ier = 1)then begin
        efface_image;
        closefile(nom_fic1);
        closefile(nom_fic2);
        exit;
      end;
      for j:=1 to nb_raie do begin
        raies_part[j].int:=raies_part[j].int*pcent_impur[i];
        nb_raie_tot:=nb_raie_tot+1;
        raies_tot[nb_raie_tot]:=raies_part[j];
        raies_tot[nb_raie_tot].wl:=lambda_calc;
      end;
      //tri en 2theta croissant
      for i:=1 to nb_raie_tot-1 do begin
        for j:=i+1 to nb_raie_tot do begin
          if (raies_tot[j].dtheta < raies_tot[i].dtheta)then begin
            raie_dummy:=raies_tot[j];
            raies_tot[j]:=raies_tot[i];
            raies_tot[i]:=raie_dummy;
          end;
        end;
      end;
  end;
  closefile(nom_fic1);
  closefile(nom_fic2);
  screen.cursor:=crdefault;
  //chdir(repertoire_donnees);
//--------------------

  if (nb_raie = 0)then begin
    fmain.canvas.brush.color:=clwhite;
    fmain.canvas.pen.color:=clblack;
    fmain.canvas.Rectangle(1,y_haut,1010,y_bas);
    fmain.listbox3.clear;
    exit;
  end;

  if (nb_raie > 0)then begin

//--------------------
    resultats;
//--------------------
    fplecran.height:=290;
    fplecran.dessine(sender);
    fplecran.visible:=true;
    beep;
  end;
end;

procedure Tfmain.edit_resultats(Sender: TObject);
//-----------------------------------------------
var
 CmdFile    : PChar;
 iwin       : Integer;
begin
  if (nb_pro = 0)then begin
    beep;
    erreur('No calculated diagram!');
    exit;
  end;
  chdir(repertoire_origine);
  CmdFile:='write.exe fstr2.out';
  iwin:=WinExec(CmdFile,5);
end;

procedure Tfmain.edition_fstr_out(Sender: TObject);
//-------------------------------------------------
var
 CmdFile    : PChar;
 iwin       : Integer;
begin
  if (nb_pro = 0)then begin
    beep;
    erreur('No calculated diagram!');
    exit;
  end;
  chdir(repertoire_origine);
  CmdFile:='write.exe fstr.out';
  iwin:=WinExec(CmdFile,5);
end;

procedure Tfmain.efface_raw(Sender: TObject);
//-------------------------------------------
begin
  nom_fichier_raw:='';
  nb_raie_raw:=0;
  flag_refresh:=true;
  fplecran.dessine(sender);
end;

procedure Tfmain.rase_general(Sender: TObject);
//---------------------------------------------
begin
  rase_resultats(sender);
  rase_coordonnees(sender);
  reset_fichier_cry;
  reset_fichier_raw;
  nb_fichier_raw:=0;
  nb_raie:=0;
  nb_pro:=0;
  nb_raie_raw:=0;
  nbraw_pro:=0;
  efface_image;
end;

procedure Tfmain.ecrit(Sender: TObject);
//--------------------------------------
begin
  nb:=listbox3.ItemIndex-1;
  fplecran.dessine(sender);
end;

procedure Tfmain.rase_coordonnees(Sender: TObject);
//------------------------------------------------
begin
  rase_coord;
end;

{*****************Acquisition du nom du fichier CRY****************************}
{Evnement OnClick de FileListBox2 slection du fichier CRY}
procedure ecrit_stringGrid1;
//--------------------------
var
  ato                       : string[4];
  c1,c2,c3,c4,c5            : string[9];
  s1,s2                     : string[12];
  i,j,ier                   : integer;
  s                         : string;
begin
  with fmain do begin
     for i:=1 to nb_atome do begin
        ato:=atome[i];
        ato:=trim(ato);
        s2:=copy(ato,1,2);
        s1:=lowercase(s2);
        s2[2]:=s1[2];
        str(x_at[i]:9:5,c1);
        str(y_at[i]:9:5,c2);
        str(z_at[i]:9:5,c3);
        str(btherm[i]:6:2,c4);
        str(pop[i]:5:2,c5);
        StringGrid1.cells[0,i]:=s2;
        StringGrid1.cells[1,i]:=labell[i];
        StringGrid1.cells[2,i]:=c1;
        StringGrid1.cells[3,i]:=c2;
        StringGrid1.cells[4,i]:=c3;
        StringGrid1.cells[5,i]:=c4;
        StringGrid1.cells[6,i]:=c5;
        StringGrid4.cells[0,i]:=copy(s2,1,2);//Neutrons
        StringGrid4.cells[1,i]:=labell[i];
        StringGrid4.cells[2,i]:=c1;
        StringGrid4.cells[3,i]:=c2;
        StringGrid4.cells[4,i]:=c3;
        StringGrid4.cells[5,i]:=c4;
        StringGrid4.cells[6,i]:=c5;
        lifermi(ato,j,ier);
        if (ier = 1)then exit else b_fermi[i]:=tab_fermi[j];
        str(b_fermi[i]:8:3,s);
        StringGrid4.cells[7,i]:=s;
      end;
    end;
end;

procedure Tfmain.efface_spectre(Sender: TObject);{
-------------------------------------------------}
begin
  efface_image;
end;

procedure Tfmain.about(Sender: TObject);
//-------------------------------------
begin
  form2.visible:=true;
end;

procedure Tfmain.acces_panel5(Sender: TObject);
//--------------------------------------------
begin
    canvas.brush.color:=clwhite;
    canvas.pen.color:=clblack;
    canvas.Rectangle(1,y_haut,1010,y_bas);
    listbox3.clear;
end;

procedure Tfmain.rase_dif_ano(Sender: TObject);
//--------------------------------------------
var
   i,j               : integer;
begin
  efface_image;
  rase_resultats(sender);
  for i:=1 to nb_wl_impur do begin
    for j:=1 to nb_element do begin
      delfi[j,i]:=0;
      delfr[j,i]:=0;
    end;
  end;
  ecrit_stringgrid2;
end;

procedure Tfmain.Choix_lp(Sender: TObject);
//-----------------------------------------
begin
  flp.visible:=true;
end;

procedure Tfmain.Acquisition_f_ano(Sender: TObject);
//--------------------------------------------------
type rec = record
  energie,f1,f2  : double;
end;
var
   nom                              : string;
   el,s2                            : string[2];
   s                                : string;
   x,y,z,x1,x2,y1,y2,z1,z2          : double;
   energie,aa,bb                    : double;
   t0,t1                            : array[1..3] of single;
   i,j,n,ier,k,l,no_elem,no_lambda  : integer;
   fichbin                          : File;
   nomf                             : textfile;
   c2                               : array[1..2] of char;
   buf                              : array[1..2000] of single;
   tas                              : array[1..2000] of {rec; //}^rec;
label 1;
begin
  if (radioGroup2.ItemIndex <> 0) and (radioGroup2.ItemIndex <> 1)then begin
    erreur('Select the File!');
    exit;
  end;
  edit1.visible:=true;
  panel2.refresh;
  if (radioGroup2.ItemIndex = 0)then nom:='Brcow.an';
  if (radiogroup2.ItemIndex = 1)then nom:='Sasaki.an';

  if (nb_element = 0)then begin
     panel2.visible:=false;
     edit1.visible:=false;
     exit;
  end;
  screen.cursor:=crHourGlass;

  for no_elem:= 1 to nb_element do begin
    //Label de l'lment
    el:=copy(element[no_elem],1,2);
    el:=trim(el);
    ier:=1;
    assignfile(fichbin,nom);
    reset(fichbin,1);
    while not(eof(fichbin)) do begin
      for j:=1 to 2 do c2[j]:=' ';
      blockread(fichbin,c2,2);
      s2:='$$';
      for j:=1 to 2 do s2[j]:=c2[j];
      s2:=trim(s2);
      s2:=uppercase(s2);
      blockread(fichbin,n,4);

      if (s2 <> el) then begin           // on a trouv #S, on lit le bloc
        for j:=1 to n do blockread(fichbin,t0,12)
      end else begin                   // On a trouv l'lment
//On stocke les valeurs pour l'lment trouv dans tas
        for i:=1 to n do begin
          new(tas[i]);
          blockread(fichbin,t1,12);
          tas[i]^.energie:=t1[1];
          tas[i]^.f1:=t1[2];
          tas[i]^.f2:=t1[3];
        end;
        for no_lambda:=1 to nb_wl_impur do begin
          energie:=12400/wl_impur[no_lambda];
          for j:=1 to n do begin
             if (tas[j]^.energie < energie) then begin
              x1:=tas[j]^.energie;
              y1:=tas[j]^.f1;
              z1:=tas[j]^.f2;
            end else begin
              x2:=tas[j]^.energie;
              y2:=tas[j]^.f1;
              z2:=tas[j]^.f2;
              x:=energie;
              aa:=(y2-y1)/(x2-x1);
              bb:=y1-aa*x1;
              y:=x*aa+bb;
              delfr[no_lambda,no_elem]:=y;
              aa:=(z2-z1)/(x2-x1);
              bb:=z1-aa*x1;
              z:=x*aa+bb;
              delfi[no_lambda,no_elem]:=z;
              if (no_lambda = nb_wl_impur) and (no_elem = nb_element) then begin
                closeFile(fichbin);
                goto 1;
              end;
              break;
            end;
          end;
        end;
        for i:=1 to n do dispose(tas[i]);
      end;
    end;
    closefile(fichbin);
  end;
1: ecrit_stringgrid2;
  Screen.Cursor:=crDefault;
  panel2.visible:=false;
  edit1.visible:=false;
  exit;
  if (nb_pro > 0) then recalcule(Sender);
end;

procedure Tfmain.bouton_lecture_ano(Sender: TObject);
//--------------------------------------------------
var
  s   : string;
  ier : integer;
begin
  s:=trim(edit11.text);
  if (s = '') or (s = '0.00000') then begin
    erreur('No WaveLength!');
    exit;
  end;
  if (s <> 'Multiple')then begin
    val(s,lambda,ier);
    if (ier > 0)then begin
      erreur('Error on WaveLength!');
      exit;
    end else begin;
      nb_wl_impur:=1;
      wl_impur[1]:=lambda;
      lambda_max:=lambda;
      lambda_min:=lambda;
      pcent_impur[1]:=1;
    end;
  end;
  reset_spectre_res(sender);
  if (nb_atome = 0)then begin
    beep;
    erreur('No atom in the asymetric unit!');
    exit;
  end;
//lit_donnees;
  radiogroup2.itemindex:=-1;
  panel2.visible:=true;
end;

procedure Tfmain.optionX(Sender: TObject);
//---------------------------------------
begin
  bitbtn2.font.color:=clred;
  bitbtn3.font.color:=clgray;
  fplecran.reset_diag(sender);
  rase_resultats(sender);
  stringGrid1.visible:=true;
  stringGrid2.visible:=true;
  stringGrid4.visible:=false;
  label18.visible:=true;
  Color95button1.visible:=true;
  type_source:=1;
  flp.visible:=true;
end;

procedure Tfmain.choixN(Sender: TObject);
//---------------------------------------
begin
  bitbtn3.font.color:=clred;
  bitbtn2.font.color:=clgray;
  Color95button1.visible:=false;
  fplecran.reset_diag(sender);
  rase_resultats(sender);
  efface_image;
  stringGrid1.visible:=false;
  stringGrid2.visible:=false;
  stringGrid4.visible:=true;
  label18.visible:=false;
  type_source:=2;
  panel7.caption:='Source: Neutrons'
end;

procedure Tfmain.reset_spectre_res(Sender: TObject);
//--------------------------------------------------
var
  i,j    : integer;
begin
  if (nb_element > 0)and (nb_wl_impur > 0)then begin
    for i:=1 to nb_element do begin
      for j:=1 to nb_wl_impur do begin
        delfr[j,i]:=0;
        delfi[j,i]:=0;
      end;
    end;
    ecrit_stringgrid2;
  end;
  effacement_spectre_res;
end;

procedure Tfmain.change_theta_2theta(Sender: TObject);
//---------------------------------------------------
begin
    efface_stringgrid2;
    theta_min:=theta_min_depart;
    theta_max:=theta_max_depart;
    q_min:=q_min_depart;
    q_max:=q_max_depart;
    case RadioGroup1.ItemIndex of
     0: begin
          edit13.font.name:='Symbol';
          edit15.font.name:='Symbol';
          edit13.text:='q1';
          edit15.text:='q2';
        end;
     1: begin
          edit13.font.name:='Symbol';
          edit15.font.name:='Symbol';
          edit13.text:='2q1';
          edit15.text:='2q2';
        end;
     2: begin
          if(lambda_min*lambda_max = 0)then begin
            erreur('WaveLength not defined!');
            RadioGroup1.ItemIndex:=-1;
            exit;
          end;
          edit13.font.name:='MS sans serif';
          edit15.font.name:='MS sans serif';
          edit13.text:='Q1';
          edit15.text:='Q2';
        end;
    end;
    disp_experiment;
    lit_donnees;
    fplecran.dessine(sender);
    if (nb_raie > 0)then begin
      ecrit_listbox3;
    end;
end;

procedure lit_fichier_cristal;
//---------------------------
var
  ier                       : integer;
  sender : tobject;
begin
  with fmain do begin
    edit8.text:='';
    edit9.text:='';
    edit12.text:='';
    systeme:='';
    effacement_spectre_res;
    OpenDialog1.filterIndex:=type_fichier_cry;
    if OpenDialog1.execute then nom_fichier_cry:=OpenDialog1.filename;
    if(length(nom_fichier_cry) > 0)then  begin
      rase_coord;
      panel4.caption:='Data'+' ('+extractFileName(nom_fichier_cry)+')';
      groupe_espace:='';
      case type_fichier_cry of
       1: lit_poudrix(ier);
       2: begin
            if (pos('.ins',nom_fichier_cry) > 0) or
            (pos('.inp', nom_fichier_cry) > 0) then lit_shelx_inp(ier);
            if (pos('.res',nom_fichier_cry) > 0) then lit_shelx_out(ier);
          end;
       3: lit_powdercell(ier);
       4: lit_lazyPulverix(ier);
       5: lit_icsd(ier);
      end;
      if (ier = 1)then exit;
      ecrit_StringGrid1;
      with listbox2 do begin
        if(systeme = 'CUBI')then ItemIndex:=0;
        if(systeme = 'TETR')then ItemIndex:=1;
        if(systeme = 'ORTH')then ItemIndex:=2;
        if(systeme = 'HEXA')then ItemIndex:=3;
        if(systeme = 'RHOM')then ItemIndex:=4;
        if(systeme = 'MONO')then ItemIndex:=5;
        if(systeme = 'TRIC')then ItemIndex:=6;
      end;

//Si le symbole a t lu
      if (groupe_espace <> '') then begin
        fgroupes.init(Sender);
        if (mode = 'HM')then fgroupes.selecte_groupe_HM(Sender)
        else fgroupes.selecte_groupe_getspec(Sender);
      end;

      set_elements;
      ecrit_stringgrid2;
      ecrit_maille;
    end else begin
      exit;
    end;
  end;
end;

procedure Tfmain.lit_fichier_cry(Sender: TObject);{
--------------------------------------------------}
begin
  type_fichier_cry:=1;
  lit_fichier_cristal;
end;

procedure Tfmain.lit_fichier_shelx(Sender: TObject);
//-------------------------------------------------
begin
  type_fichier_cry:=2;
  lit_fichier_cristal;
end;

procedure Tfmain.powdercell_format(Sender: TObject);
//-------------------------------------------------
begin
  type_fichier_cry:=3;
  lit_fichier_cristal;
end;

procedure Tfmain.icsd_format(Sender: TObject);
//------------------------------------------
begin
  type_fichier_cry:=5;
  lit_fichier_cristal;
end;

procedure Tfmain.pulverix_format(Sender: TObject);
//---------------------------------------------------
begin
  type_fichier_cry:=4;
  lit_fichier_cristal;
end;

procedure Tfmain.set_lambda(Sender: TObject);
//-------------------------------------------
const
  tab_wl:array[1..20] of double =(0.70930,0.71359,0.71070,0.63229,1.54056,1.54439,
  1.54180,1.39222,1.78897,1.79285,1.79020,1.62079,1.93604,1.93339,1.93730,
  1.75661,2.28970,2.29361,2.29090,2.08487);
var
  s: string;
begin
  efface_stringgrid2;
  reset_spectre_res(sender);
  nb_wl_impur:=0;
  if (listbox4.ItemIndex = 0)then begin
    lambda:=0;
    fimpur.visible:=true;
    fimpur.Show;
    exit;
  end;

//Type d'anode
  s:=listbox4.Items[listbox4.ItemIndex];
  anode_calc:=copy(s,1,2);

  lambda:=tab_wl[listbox4.ItemIndex];
  lambda_min:=lambda;
  lambda_max:=lambda;
  if (theta_max > 0)then begin
    q_min:=4*pi*sin(theta_min/114.5914)/lambda_max;
    q_max:=4*pi*sin(theta_max/114.5914)/lambda_min;
    q_min_depart:=q_min;
    q_max_depart:=q_max;
  end else begin
    q_min:=0;
    q_max:=0;
    q_min_depart:=q_min;
    q_max_depart:=q_max;
  end;
  str(lambda:8:5,s);
  edit11.text:=s;
  nb_wl_impur:=1;
  wl_impur[1]:=lambda;
  lambda_max:=lambda;
  lambda_min:=lambda;
  pcent_impur[1]:=1;
  lit_donnees;
  ecrit_stringgrid2;
  disp_experiment
end;

procedure Tfmain.StringGrid1DblClick(Sender: TObject);
//---------------------------------------------------
var
  i,j:integer;
begin
  with stringgrid1 do begin
    for j:=nb_atome downto no_ligne do
    for i:=0 to colcount-1 do cells[i,j+1]:=cells[i,j];
    for i:=0 to colcount do cells[i,no_ligne]:='';
  end;
end;

procedure Tfmain.peint_stinggrid1(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
//------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;


procedure Tfmain.peint_stringgrid4(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid4.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid4.canvas.textWidth(s)) div 2;
  stringgrid4.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfmain.peint_stringgrid2(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
 if (row = 1) then begin
      stringgrid2.canvas.brush.color:=$D6FFE8;
      stringgrid2.canvas.fillrect(rect);
      stringgrid2.canvas.font.color:=clred;
      stringgrid2.canvas.pen.color:=clblack;
      stringgrid2.canvas.textout(rect.left+2,rect.top+2,stringgrid2.cells[col,row]);
 end;
 s:=stringgrid2.cells[col,row];
 posx:= ((Rect.right-rect.left-2)-stringgrid2.canvas.textWidth(s)) div 2;
 stringgrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfmain.cancel_panel2(Sender: TObject);
//---------------------------------------------
begin
  panel2.visible:=false;
end;

procedure Tfmain.entree_lambda(Sender: TObject);
//---------------------------------------------
begin
  reset_spectre_res(Sender);
  numero_case(sender);
end;

procedure Tfmain.BitBtn4Click(Sender: TObject);
//--------------------------------------------
var
  i,j   : integer;
begin
  if (systeme = '')then exit;
  if (nb_element > 0)and (nb_wl_impur > 0)then begin
    for i:=1 to nb_element do begin
      for j:=1 to nb_wl_impur do begin
        delfr[j,i]:=0;
        delfi[j,i]:=0;
      end;
    end;
    ecrit_stringgrid2;
  end;
  effacement_spectre_res;
  fgroupes.visible:=true;
end;

procedure Tfmain.cif_format(Sender: TObject);
//------------------------------------------
var
  i,n,ier            : integer;
  s              : string;
  nomf           : textfile;
begin
    if FileExists('dummy.cif') then DeleteFile('dummy.cif');
    type_fichier_cry:=6;
    edit8.text:='';
    edit9.text:='';
    edit12.text:='';
    systeme:='';
    effacement_spectre_res;
    OpenDialog1.filterIndex:=type_fichier_cry;
    if OpenDialog1.execute then nom_fichier_cry:=OpenDialog1.filename;
    if(length(nom_fichier_cry) > 0)then  begin
      rase_coord;
      panel4.caption:='Data'+' ('+extractFileName(nom_fichier_cry)+')';
      groupe_espace:='';

//Plusieurs blocs?
      AssignFile(nomf,nom_fichier_cry);
      reset(nomf);
      nb_blocs:=0;
      n:=0;
      nb_ligne_choisi:=0;
      while not(eof(nomf)) do begin
        readln(nomf,s);
        n:=n+1;
        s:=trim(s);
       //s:=lowercase(s);
        if (s = 'data_global')then continue;
        if (pos('data_',s) = 1)then begin
          nb_blocs:=nb_blocs+1;
          blocs[nb_blocs]:=s;
          no_ligne_bloc[nb_blocs]:=n;
          if (nb_blocs = 1)then nb_ligne_choisi:=n;
        end;
      end;
      closefile(nomf);
      if (nb_blocs > 1)then form3.visible:=true else lit_fichier_cif(ier);
    end;
end;

end.
