unit getspc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons;

type
  TForm1 = class(TForm)
    ListBox3: TListBox;
    ListBox2: TListBox;
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    procedure selecte_systeme(Sender: TObject);
    procedure selecte_groupe(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

uses
oemath;

{---DLL GETSPEC-----------------------------------------------------------}
procedure getspc(var tabmes          : tab_mess);
                 far;stdcall;external 'getspec.dll' index 1;


procedure dec_val(s:string;var r:vecteur3;var t:real);
//---------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,n  : integer;
const
  cxyz : array[1..8] of string[3]=
  ('X','Y','Z','-X','-Y','-Z','X-Y','Y-X');
  vxyz : array [1..24] of real=
  ( 1, 0, 0, 0, 1, 0, 0, 0, 1,-1, 0, 0 ,0,-1, 0, 0, 0,-1,1,-1, 0,-1, 1, 0);
  ct   : array[1..15] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6','-1/2',
  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6');
  vt   : array[1..15] of real =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333,-0.5,
  -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333);
begin
  t:=0;
  s:=trim(s);

  //Recherche de la translation ==> t
  for i:=1 to 15 do begin
    if (pos(ct[i],s) > 0)then begin
      t:=vt[i];
      break;
    end;
  end;
  if (t <> 0)then begin
    delete(s,pos(ct[i],s),4);
  end;

  //Recherche de la position ==> vecteur r
  for i:=1 to 15 do begin
    if (cxyz[i] = s)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      exit;
    end;
  end;

end;

procedure code(var v:vecteur4; var s:string);
//------------------------------------------
//code une v=vecteur[4] en s=chaine contenant une position
var
  i         : integer;
  s1,s2     : string;
const
  cxyz : array[1..8] of string[4]=
  (' X',' Y',' Z','-X','-Y','-Z',' X-Y',' Y-X');
  sxyz : array [1..8] of string =
  ( '1 0 0','0 1 0','0 0 1','-1 0 0','0-1 0','0 0-1','1-1 0','-1 1 0');
  ct   : array[1..8] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6');
  vt   : array[1..8] of double =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333);
begin
  s:='';
  s2:='';
  str(v[1]:2:0,s1);
  s2:=s2+s1;
  str(v[2]:2:0,s1);
  s2:=s2+s1;
  str(v[3]:2:0,s1);
  s2:=s2+s1;
  s2:=trim(s2);
  while (pos('-0',s2) > 0) do begin
    i:=pos('-0',s2);
    s2[i]:=' ';
  end;
  s2:=trim(s2);
  for i:=1 to 8 do begin
    if (sxyz[i] = s2)then begin
      s:=cxyz[i];
    end;
  end;

  //Translation
  if(v[4] = 0)then exit;
  if (v[4] < 0)then v[4]:=1+v[4];
  if (v[4] > 1) then v[4]:=v[4]-1;
  for i:=1 to 8 do begin
    if (abs(v[4]-vt[i]) < 0.001)then begin
      s1:=ct[i];
      s:=s+s1;
      exit;
    end;
  end;
end;

procedure set_centre;
//------------------
var
  i,j,k            :  integer;
begin
    for i:=1 to npos do begin
      for j:=1 to 3 do begin
        for k:=1 to 3 do tp[npos+i,j,k]:=-tp[i,j,k];
        tp[npos+i,j,4]:=tp[i,j,4];
      end;
    end;
    npos:=2*npos;
end;

//Etablit les translations de rseau;
procedure set_translations;{
---------------------------}
var
  i,j,k,it,nn,ii                : integer;
begin
  nbtrans:=0;
  if (systeme = 'HEXA') and (bravais = 'R') then begin
    nbtrans:=2;
    tx[1]:=0.3333333333;
    ty[1]:=0.6666666666;
    tz[1]:=0.6666666666;
    tx[2]:=0.6666666666;
    ty[2]:=0.3333333333;
    tz[2]:=0.3333333333;
  end;
  if (bravais = 'F') then begin
    nbtrans:=3;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
    tx[2]:=0.5;
    ty[2]:=0;
    tz[2]:=0.5;
    tx[3]:=0.5;
    ty[3]:=0.5;
    tz[3]:=0;
  end;
  if (bravais = 'I') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5 ;
    tz[1]:=0.5;
  end;
  if (bravais = 'A') then begin
    nbtrans:=1;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
  end;
  if (bravais = 'B') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0;
    tz[1]:=0.5;
  end;
  if (bravais = 'C') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5;
    tz[1]:=0;
  end;

  // Si le nb de translations est >0 on implmente le set d'oprateurs de
  // symtrie.
  if(nbtrans > 0) then begin
    nn:=npos;
    for it:=1 to nbtrans do begin
      for i:=1 to npos do begin
        nn:=nn+1;
        for j:=1 to 3 do begin
          for k:=1 to 4 do tp[nn,j,k]:=tp[i,j,k];
        end;
        tp[nn,1,4]:=tp[nn,1,4]+tx[it];
        tp[nn,2,4]:=tp[nn,2,4]+ty[it];
        tp[nn,3,4]:=tp[nn,3,4]+tz[it];
        for ii:=1 to 3 do if(tp[nn,ii,4] > 1) then tp[nn,ii,4]:=tp[nn,ii,4]-1;
      end;
    end;
    npos:=nn;
  end;

end;

Procedure set_positions;{
------------------------}
var
  i,j,n                            : integer;
  s,s1                             : string;
  t                                : real;
  r                                : vecteur3;
  nom                              : textfile;

begin
  s:=trim(systeme)+'.pos';
  chdir(repertoire_origine);
  AssignFile(nom,s);
  reset(nom);
  while not(eof(nom)) do begin
    readln(nom,s);
    s:=trimRight(s);
    if (s = groupe_espace)then begin
      readln(nom,centre);
      readln(nom,npos);
      for i:=1 to npos do begin
        readln(nom,s);
        s_pos[i]:=s;
        s:=ansiuppercase(s);
        s_pos[i]:=s;
        //X
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dec_val(s1,r,t);
        for j:=1 to 3 do tp[i,1,j]:=r[j];
        tp[i,1,4]:=t;
        //Y
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dec_val(s1,r,t);
        for j:=1 to 3 do tp[i,2,j]:=r[j];
        tp[i,2,4]:=t;
        //Z
        dec_val(s,r,t);
        for j:=1 to 3 do tp[i,3,j]:=r[j];
        tp[i,3,4]:=t;
      end;
      readln(nom,n);
      if(n > 0)then for i:=1 to n do readln(nom,s);
      break;
    end;
  end;
  npos_gene:=npos;
  closeFile(nom);
end;

//Extrait jusqu'a 12 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..12] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
 end;

 procedure affiche_groupes_getspec;
//--------------------------------
//Groupes Getspec
var
  i,j,i1,i2            : integer;
  s                    : string;
  s12                  : string;
  s21                  : string;
  s4                   : string;
  nomf                 : textfile;
begin
  if (systeme = 'TRIC')then begin
    i1:=1;
    i2:=18;
  end else if (systeme = 'MONO')then begin
    i1:=19;
    i2:=178;
  end else if (systeme = 'ORTH')then begin
    i1:=179;
    i2:=370;
  end else if (systeme = 'TETR')then begin
    i1:=371;
    i2:=480;
  end else if (systeme = 'RHOM')then begin
    i1:=481;
    i2:=525;
  end else if (systeme = 'HEXA')then begin
    i1:=526;
    i2:=557;
  end else if (systeme = 'CUBI')then begin
    i1:=558;
    i2:=637;
  end;
  nb_groupes_getspec:=i2-i1+1;

  form1.listbox3.clear;
  assignfile(nomf,'spgr.dat');
  reset(nomf);
  if (i1 > 1)then begin
    for i:=1 to i1-1 do readln(nomf);
  end;
  for i:=1 to i2-i1+1 do begin
      readln(nomf,s);
      s12:=copy(s,6,12);s12:=trim(s12);
      if (length(s12) < 12)then for j:=length(s12)+1 to 12 do s12:=s12+' ';
      s21:=copy(s,27,20);s21:=trim(s21);
      if (length(s21) < 17)then for j:=length(s21)+1 to 17 do s21:=s21+' ';
      s4:=copy(s,47,3);s4:=trim(s4);
      if (length(s4) < 3)then for j:=length(s4)+1 to 3 do s4:=s4+' ';
      form1.listbox3.items.add(s12+s21+s4);
  end;
  closefile(nomf);
end;

procedure ecrit_stringgrid1;
//--------------------------
var
  i,j,k         : integer;
  s             : string;
  v4            : vecteur4;
begin
  with form1.StringGrid1 do begin
    cells[0,0]:='Nb';
    cells[1,0]:='a';
    cells[2,0]:='b';
    cells[3,0]:='c';
    cells[4,0]:='Selected';

    if (npos = 0)then exit;
    for i:=1 to rowcount-1 do
      for j:=0 to 4 do cells[j,i]:='';

    for i:=1 to npos do begin
      str(i:3,s);
      cells[0,i]:=inttostr(i);
      s_pos[i]:='';
      for j:=1 to 3 do begin
        for k:=1 to 4 do v4[k]:=tp[i,j,k];
        code(v4,s);
        s:=uppercase(s);
        cells[j,i]:=s;
        s_pos[i]:=s_pos[i]+s+',';
      end;
      if (selected[i] = 1)then cells[4,i]:= '*';
      delete(s_pos[i],length(s_pos[i]),1);
    end;
  end;
end;

procedure TForm1.selecte_systeme(Sender: TObject);
//------------------------------------------------
begin
  listbox3.clear;
  systeme:=uppercase(copy(listbox2.Items[listbox2.itemIndex],1,4));
  affiche_groupes_getspec;
end;

procedure TForm1.selecte_groupe(Sender: TObject);
//----------------------------------------------
var
   i,j,k,ier,no             : integer;
   v4                       : vecteur4;
   s,s1                     : string;
   c                        : char;
   tabmes                   : tab_mess;
   nomf                     : textfile;
   tableau                  : tab_reel;
begin
  if fileExists('scfs.dat')then deletefile('scfs.dat');
  s:='';
  s:=listbox3.items[listbox3.itemIndex];
  s:=copy(s,1,12);
  s:=trim(s);
  groupe_espace:=s;
  bravais:=copy(groupe_espace,1,1);
  for i:=1 to length(s) do begin
    c:=s[i];
    tabmes[i]:=ord(c);
  end;
  if (length(s) < 16)then begin
    for i:=length(s)+1 to 16 do tabmes[i]:=32;
  end;

  getspc(tabmes);

//Lecture des positions gnres
  assignfile(nomf,'scfs.dat');
  reset(nomf);
  npos:=0;
  readln(nomf);
  while not(eof(nomf)) do begin
    readln(nomf,s);
    while (pos(' .',s)> 0)  do insert(' 0',s,pos(' .',s)+1);
    while (pos('-.',s)> 0) do insert('0',s,pos(' -.',s)+1);
    dec(s,tableau,no,ier);
    npos:=npos+1;
    for i:=1 to 3 do tp[npos,1,i]:=tableau[i];
    tp[npos,1,4]:=tableau[4];
    for i:=1 to 3 do tp[npos,2,i]:=tableau[i+4];
    tp[npos,2,4]:=tableau[8];
    for i:=1 to 3 do tp[npos,3,i]:=tableau[i+8];
    tp[npos,3,4]:=tableau[12];
  end;
  closefile(nomf);

//Codage des positions
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      s:=s+s1+',';
    end;
    s_pos[i]:=copy(s,1,length(s)-1);
    selected[i]:=0;
  end;

//Translations
  set_translations;
  flag_modif_data:=1;
  ecrit_stringgrid1;

end;

procedure TForm1.sortie(Sender: TObject);
//---------------------------------------
begin
  close;
end;

procedure TForm1.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//---------------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
//s:=trim(Stringgrid1.cells[4,row]);
  stringgrid1.canvas.brush.color:=clsilver;
  s:=stringgrid1.cells[col,row];
  //On numrote si le numro est absent
  if (col >= 0) and (stringgrid1.cells[0,row] = '') and
  (stringgrid1.cells[1,row] <> '')then
  stringgrid1.cells[0,row]:=inttostr(row);
  //centrage
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

end.
