unit groupes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids;

type
  Tfgroupes = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    ListBox3: TListBox;
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    ListBox1: TListBox;
    procedure selecte_groupe_getspec(Sender: TObject);
    procedure init(Sender: TObject);
    procedure sortie_ok(Sender: TObject);
    procedure sortie_cancel(Sender: TObject);
    procedure selecte_groupe_HM(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fgroupes: Tfgroupes;

//procedure toto;

implementation

{$R *.DFM}

uses
  mathhkl, main;

{---DLL GETSPEC-----------------------------------------------------------}
procedure getdll(var tabmes          : tab_mess2);
                 far;stdcall;external 'getdll.dll' index 1;


procedure dek_val(s:string;var r:vecteur3;var t:double);
//---------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,n  : integer;
const
  cxyz : array[1..8] of string[3]=
  ('X','Y','Z','-X','-Y','-Z','X-Y','Y-X');
  vxyz : array [1..24] of double=
  ( 1, 0, 0, 0, 1, 0, 0, 0, 1,-1, 0, 0 ,0,-1, 0, 0, 0,-1,1,-1, 0,-1, 1, 0);
  ct   : array[1..15] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6','-1/2',
  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6');
  vt   : array[1..15] of double =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333,-0.5,
  -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333);
begin
  t:=0;
  s:=trim(s);

  //Recherche de la translation ==> t
  for i:=1 to 15 do begin
    if (pos(ct[i],s) > 0)then begin
      t:=vt[i];
      break;
    end;
  end;
  if (t <> 0)then begin
    delete(s,pos(ct[i],s),4);
  end;

  //Recherche de la position ==> vecteur r
  for i:=1 to 15 do begin
    if (cxyz[i] = s)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      exit;
    end;
  end;

end;

procedure code(var v:vecteur4; var s:string);
//------------------------------------------
//code une v=vecteur[4] en s=chaine contenant une position
var
  i         : integer;
  s1,s2     : string;
const
  cxyz : array[1..8] of string[4]=
  (' X',' Y',' Z','-X','-Y','-Z',' X-Y',' Y-X');
  sxyz : array [1..8] of string =
  ( '1 0 0','0 1 0','0 0 1','-1 0 0','0-1 0','0 0-1','1-1 0','-1 1 0');
  ct   : array[1..8] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6');
  vt   : array[1..8] of double =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333);
begin
  s:='';
  s2:='';
  str(v[1]:2:0,s1);
  s2:=s2+s1;
  str(v[2]:2:0,s1);
  s2:=s2+s1;
  str(v[3]:2:0,s1);
  s2:=s2+s1;
  s2:=trim(s2);
  while (pos('-0',s2) > 0) do begin
    i:=pos('-0',s2);
    s2[i]:=' ';
  end;
  s2:=trim(s2);
  for i:=1 to 8 do begin
    if (sxyz[i] = s2)then begin
      s:=cxyz[i];
    end;
  end;

  //Translation
  if(v[4] = 0)then exit;
  if (v[4] < 0)then v[4]:=1+v[4];
  if (v[4] > 1) then v[4]:=v[4]-1;
  for i:=1 to 8 do begin
    if (abs(v[4]-vt[i]) < 0.001)then begin
      s1:=ct[i];
      s:=s+s1;
      exit;
    end;
  end;
end;

//Etablit les translations de rseau;
procedure set_translations;{
---------------------------}
var
  i,j,k,it,nn,ii                : integer;
begin
  nb_translation:=0;
  if (systeme = 'HEXA') and (bravais = 'R') then begin
    nb_translation:=2;
    tx[1]:=0.3333333333;
    ty[1]:=0.6666666666;
    tz[1]:=0.6666666666;
    tx[2]:=0.6666666666;
    ty[2]:=0.3333333333;
    tz[2]:=0.3333333333;
  end;
  if (bravais = 'F') then begin
    nb_translation:=3;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
    tx[2]:=0.5;
    ty[2]:=0;
    tz[2]:=0.5;
    tx[3]:=0.5;
    ty[3]:=0.5;
    tz[3]:=0;
  end;
  if (bravais = 'I') then begin
    nb_translation:=1;
    tx[1]:=0.5;
    ty[1]:=0.5 ;
    tz[1]:=0.5;
  end;
  if (bravais = 'A') then begin
    nb_translation:=1;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
  end;
  if (bravais = 'B') then begin
    nb_translation:=1;
    tx[1]:=0.5;
    ty[1]:=0;
    tz[1]:=0.5;
  end;
  if (bravais = 'C') then begin
    nb_translation:=1;
    tx[1]:=0.5;
    ty[1]:=0.5;
    tz[1]:=0;
  end;

  // Si le nb de translations est >0 on implmente le set d'oprateurs de
  // symtrie.
  if(nb_translation > 0) then begin
    nn:=npos;
    for it:=1 to nb_translation do begin
      for i:=1 to npos do begin
        nn:=nn+1;
        for j:=1 to 3 do begin
          for k:=1 to 4 do tp[nn,j,k]:=tp[i,j,k];
        end;
        tp[nn,1,4]:=tp[nn,1,4]+tx[it];
        tp[nn,2,4]:=tp[nn,2,4]+ty[it];
        tp[nn,3,4]:=tp[nn,3,4]+tz[it];
        for ii:=1 to 3 do if(tp[nn,ii,4] > 1) then tp[nn,ii,4]:=tp[nn,ii,4]-1;
      end;
    end;
    npos:=nn;
  end;

end;

//Extrait jusqu'a 12 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dek(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..12] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
 end;

 procedure affiche_groupes_getspec;
//--------------------------------
//Groupes Getspec
var
  i,j,i1,i2            : integer;
  s                    : string;
  s12                  : string;
  s21                  : string;
  s4                   : string;
  nomf                 : textfile;
begin
  if (systeme = 'TRIC')then begin
    i1:=1;
    i2:=18;
  end else if (systeme = 'MONO')then begin
    i1:=19;
    i2:=178;
  end else if (systeme = 'ORTH')then begin
    i1:=179;
    i2:=370;
  end else if (systeme = 'TETR')then begin
    i1:=371;
    i2:=480;
  end else if (systeme = 'HEXA')then begin
    i1:=481;
    i2:=547;
  end else if (systeme = 'RHOM')then begin
    i1:=548;
    i2:=556;
  end else if (systeme = 'CUBI')then begin
    i1:=558;
    i2:=637;
  end;
    nb_groupes_getspec:=i2-i1+1;

  fgroupes.listbox3.clear;
  chdir(repertoire_origine);
  assignfile(nomf,'spgr2.dat');
  reset(nomf);
  if (i1 > 1)then begin
    for i:=1 to i1-1 do readln(nomf);
  end;
  for i:=1 to i2-i1+1 do begin
      readln(nomf,s);
      s12:=copy(s,6,12);s12:=trim(s12);
      if (length(s12) < 12)then for j:=length(s12)+1 to 12 do s12:=s12+' ';
      s21:=copy(s,27,20);s21:=trim(s21);
      if (length(s21) < 17)then for j:=length(s21)+1 to 17 do s21:=s21+' ';
      s4:=copy(s,47,3);s4:=trim(s4);
      if (length(s4) < 3)then for j:=length(s4)+1 to 3 do s4:=s4+' ';
      fgroupes.listbox3.items.add(s12+s21+s4);
  end;
  closefile(nomf);
end;

procedure affiche_groupes_HM;{
-----------------------------}
//Affichage des groupes du systeme dans ListBox1
var
  nomf                    : TextFile;
  s                       : string;
  i                       : integer;
begin
  if (systeme = '')then exit;

  fgroupes.listbox1.items.clear;
  chdir(repertoire_origine);
  s:=copy(systeme,1,1)+'.pos';
  if (systeme = 'TETR') then s:='Q.POS';
  assignFile(nomf,s);
  reset(nomf);
  nb_groupes_HM:=0;
  while not (eof(nomf)) do begin
    readln(nomf,s);
    s:=TrimRight(s);
    if(length(s) = 0)then begin
      readln(nomf,s);
      s:=trim(s);
      fgroupes.listbox1.items.add(s);
      nb_groupes_HM:=nb_groupes_HM+1;
    end;
  end;
  closeFile(nomf);

//Allumage du groupe d'espace dans listbox1
  if(length(groupe_espace) > 0)then begin
    for i:=1 to nb_groupes_HM do begin
      s:=fgroupes.listbox1.items.strings[i-1];
      s:=TrimRight(s);
      if(groupe_espace = s) then begin
        fgroupes.listbox1.ItemIndex:=i-1;
        break;
      end;
    end;
  end;
end;

procedure ecrit_fichier_espion;
//----------------------------
var
  nomf          : textfile;
  i,j           : integer;
  s             : string;
begin
 if (mode = 'HM')then assignfile(nomf,'hm.txt')
 else assignfile(nomf,'gtsp.txt');
 rewrite(nomf);
 for i:=1 to npos do begin
   writeln(nomf,i:4,'  ',s_pos[i]);
 end;
 closefile(nomf);
end;

procedure write_stringgrid1;
//--------------------------
var
  i,j,k         : integer;
  s             : string;
  v4            : vecteur4;
begin
  with fgroupes.StringGrid1 do begin
    rowcount:=npos+1;
    cells[0,0]:='Nb';
    cells[1,0]:='a';
    cells[2,0]:='b';
    cells[3,0]:='c';
    cells[4,0]:='Selected';

    if (npos = 0)then exit;
    for i:=1 to rowcount-1 do
      for j:=0 to 4 do cells[j,i]:='';

    for i:=1 to npos do begin
      str(i:3,s);
      cells[0,i]:=inttostr(i);
      s_pos[i]:='';
      for j:=1 to 3 do begin
        for k:=1 to 4 do begin
          v4[k]:=tp[i,j,k];
        end;
        code(v4,s);
        s:=uppercase(s);
        cells[j,i]:=s;
        s_pos[i]:=s_pos[i]+s+',';
      end;
      delete(s_pos[i],length(s_pos[i]),1);
    end;
  end;
end;

procedure Tfgroupes.selecte_groupe_getspec(Sender: TObject);
//--------------------------------------------------
var
   i,j,k,ier,no             : integer;
   v4                       : vecteur4;
   s,s1                     : string;
   c                        : char;
   tabmes                   : tab_mess2;
   nomf                     : textfile;
   tableau                  : tab_reel;
begin
  //toto;
  mode:='HALL';
  listbox1.ItemIndex:=-1;
  if fileExists('scfs2.dat')then deletefile('scfs2.dat');
  s:='';
  s:=listbox3.items[listbox3.itemIndex];
  with fmain do begin
    edit8.text:=trim(copy(s,1,12));
    edit9.text:=trim(copy(s,12,14));
    edit12.text:=trim(copy(s,29,4));
  end;
  s:=copy(s,1,12);
  s:=trim(s);
  groupe_espace:=s;
  bravais:=copy(groupe_espace,1,1);
  for i:=1 to length(s) do begin
    c:=s[i];
    tabmes[i]:=ord(c);
  end;
  if (length(s) < 16)then begin
    for i:=length(s)+1 to 16 do tabmes[i]:=32;
  end;

  getdll(tabmes);

//Lecture des positions gnres
  assignfile(nomf,'scfs.dat');
  reset(nomf);
  npos:=0;
  readln(nomf);
  while not(eof(nomf)) do begin
    readln(nomf,s);
    if (s = '')then break;
    while (pos(' .',s)> 0) do insert(' 0',s,pos(' .',s)+1);
    while (pos('-.',s)> 0) do insert('0',s,pos(' -.',s)+1);
    dek(s,tableau,no,ier);
    npos:=npos+1;
    for i:=1 to 3 do tp[npos,1,i]:=tableau[i];
    tp[npos,1,4]:=tableau[4];
    for i:=1 to 3 do tp[npos,2,i]:=tableau[i+4];
    tp[npos,2,4]:=tableau[8];
    for i:=1 to 3 do tp[npos,3,i]:=tableau[i+8];
    tp[npos,3,4]:=tableau[12];
  end;
  icent:=0;
  centre:=false;
  for i:=1 to 4 do readln(nomf);
  for i:=1 to npos do begin
    readln(nomf,s);
    if (s = '')then break;
    delete(s,1,7);
    if (pos('-X,-Y,-Z',s) > 0)then begin
      centre:=true;
      break;
    end;
  end;
  closefile(nomf);

//Translations
  set_translations;
  write_stringgrid1;

end;

procedure Tfgroupes.init(Sender: TObject);
//----------------------------------------
var
  i             : integer;
  s             : string;
begin
  top:=0;
  if (systeme = '')then exit;
  affiche_groupes_getspec;
  affiche_groupes_HM;
  if (groupe_espace <> '')then begin
    for i:=1 to nb_groupes_getspec do begin
      s:=copy(listbox3.items[i-1],1,12);
      s:=trim(s);
      if (s = groupe_espace) then begin
        listbox3.itemindex:=i-1;
        selecte_groupe_getspec(Sender);
        exit;
      end;
    end;
    for i:=1 to nb_groupes_HM do begin
      s:=listbox1.items[i-1];
      s:=trim(s);
      if (s = groupe_espace) then begin
        listbox1.itemindex:=i-1;
        selecte_groupe_HM(Sender);
        exit;
      end;
    end;
    erreur(groupe_espace+' unknown space group');
    groupe_espace:='';
  end;
end;

procedure Tfgroupes.sortie_ok(Sender: TObject);
//-----------------------------------------------
begin
  if (groupe_espace = '')then begin
    beep;
    erreur('No selected group!');
    exit;
  end;
  close;
end;

procedure Tfgroupes.sortie_cancel(Sender: TObject);
//------------------------------------------------
begin
  close;
end;

Procedure set_positions;{
------------------------}
var
  i,j,n                            : integer;
  s,s1                             : string;
  t                                : double;
  r                                : vecteur3;
  nom                              : textfile;

begin
  s:=trim(copy(systeme,1,1))+'.pos';
  if (systeme = 'TETR')then s:='q.pos';
  AssignFile(nom,s);
  reset(nom);
  while not(eof(nom)) do begin
    readln(nom,s);
    s:=trimRight(s);
    if (s = groupe_espace)then begin
      readln(nom,icent);
      readln(nom,npos);
      for i:=1 to npos do begin
        readln(nom,s);
        s_pos[i]:=s;
        s:=ansiuppercase(s);
        s_pos[i]:=s;
//X
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dek_val(s1,r,t);
        for j:=1 to 3 do tp[i,1,j]:=r[j];
        tp[i,1,4]:=t;
//Y
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dek_val(s1,r,t);
        for j:=1 to 3 do tp[i,2,j]:=r[j];
        tp[i,2,4]:=t;
//Z
        dek_val(s,r,t);
        for j:=1 to 3 do tp[i,3,j]:=r[j];
        tp[i,3,4]:=t;
      end;
      readln(nom,n);
      if(n > 0)then for i:=1 to n do readln(nom,s);
      break;
    end;
  end;
  closeFile(nom);
end;

procedure set_centre;
//------------------
var
  i,j,k            :  integer;
begin
    for i:=1 to npos do begin
      for j:=1 to 3 do begin
        for k:=1 to 3 do tp[npos+i,j,k]:=-tp[i,j,k];
        tp[npos+i,j,4]:=tp[i,j,4];
      end;
    end;
    npos:=2*npos;
end;

procedure Tfgroupes.selecte_groupe_HM(Sender: TObject);
//-------------------------------------------------
var
   i,j,k                    : integer;
   v4                       : vecteur4;
   s,s1                     : string;
begin
  //affiche_groupes_HM;
  mode:='HM';
  groupe_espace:=trim(fgroupes.listbox1.items[fgroupes.listbox1.itemindex]);
  with fmain do begin
    edit8.text:=groupe_espace;
    edit9.text:='';
    edit12.text:='';
  end;
  listbox3.itemIndex:=-1;
  bravais:=copy(groupe_espace,1,1);
  set_positions;
  if (icent = 1)then begin
    set_centre;
    centre:=true;
  end;
  set_translations;
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      if (j > 1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
    end;
    s_pos[i]:=s;
  end;
  write_stringgrid1;
end;

end.
