unit impur;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tfimpur = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    Label5: TLabel;
    procedure lit_composition(Sender: TObject);
    procedure set_lambda(Sender: TObject);
    procedure annule(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
//Lecture de la composition spectrale de la source
var
  fimpur: Tfimpur;

implementation

{$R *.DFM}
uses
    main,mathhkl;

procedure Tfimpur.lit_composition(Sender: TObject);
//-------------------------------------------------
var
   s                    : string;
   x                    : double;
   ier,i,j              : integer;
begin
  nb_wl_impur:=0;
  lambda:=0;
  s:=edit1.text;
  if (s <> '')then begin
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit1.setfocus;
      exit;
    end;
    nb_wl_impur:=nb_wl_impur+1;
    wl_impur[nb_wl_impur]:=x;
    s:=edit5.text;
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit5.setfocus;
      exit;
    end;
    pcent_impur[nb_wl_impur]:=x;
    if (x = 0)then begin
      nb_wl_impur:=nb_wl_impur-1;
      edit1.text:='';
      edit5.text:='';
    end;
  end;

  s:=edit2.text;
  if (s <> '')then begin
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit2.setfocus;
      exit;
    end;
    nb_wl_impur:=nb_wl_impur+1;
    wl_impur[nb_wl_impur]:=x;
    s:=edit6.text;
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit6.setfocus;
      exit;
    end;
    pcent_impur[nb_wl_impur]:=x;
    if (x = 0)then begin
      nb_wl_impur:=nb_wl_impur-1;
      edit2.text:='';
      edit6.text:='';
    end;
  end;

  s:=edit3.text;
  if (s <> '')then begin
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit3.setfocus;
      exit;
    end;
    nb_wl_impur:=nb_wl_impur+1;
    wl_impur[nb_wl_impur]:=x;
    s:=edit7.text;
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit7.setfocus;
      exit;
    end;
    pcent_impur[nb_wl_impur]:=x;
    if (x = 0)then begin
      nb_wl_impur:=nb_wl_impur-1;
      edit3.text:='';
      edit7.text:='';
    end;
  end;

  s:=edit4.text;
  if (s <> '')then begin
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit4.setfocus;
      exit;
    end;
    nb_wl_impur:=nb_wl_impur+1;
    wl_impur[nb_wl_impur]:=x;
    s:=edit8.text;
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Type error');
      edit8.setfocus;
      exit;
    end;
    pcent_impur[nb_wl_impur]:=x;
    if (x = 0)then begin
      nb_wl_impur:=nb_wl_impur-1;
      edit4.text:='';
      edit8.text:='';
    end;
  end;
  x:=0;
  for i:=1 to nb_wl_impur do x:=x+pcent_impur[i];
  for i:=1 to nb_wl_impur do pcent_impur[i]:=pcent_impur[i]/x;

  //Rangement en lambda dcroissant (Energie croissante)
  if (nb_wl_impur > 1)then begin
    for i:=1 to nb_wl_impur-1 do begin
      for j:=i+1 to nb_wl_impur do begin
        if (wl_impur[i] > wl_impur[j])then begin
          x:=wl_impur[i];
          wl_impur[i]:=wl_impur[j];
          wl_impur[j]:=x;
          x:=pcent_impur[i];
          pcent_impur[i]:=pcent_impur[j];
          pcent_impur[j]:=x;
        end;
      end;
    end;
  end;

  if (nb_wl_impur > 0)then begin
    lambda_min:=1000;
    lambda_max:=0;
    for i:=1 to nb_wl_impur do begin
      if (wl_impur[i] > lambda_max)then lambda_max:=wl_impur[i];
      if (wl_impur[i] < lambda_min)then lambda_min:=wl_impur[i];
    end;
    q_min:=4*pi*sin(theta_min/114.5916)/lambda_max;
    q_max:=4*pi*sin(theta_max/114.5916)/lambda_min;
    disp_experiment;
  end;

  if (nb_wl_impur = 0)then begin
    erreur('No Wavelength!');
    exit;
  end else begin
    for i:=1 to nb_element do begin
      for j:=1 to nb_wl_impur do begin
        delfr[j,i]:=0;
        delfi[j,i]:=0;
      end;
    end;
  end;

//!!!!
  lambda:=wl_impur[1];
//!!!!



  fimpur.visible:=false;
  ecrit_stringgrid2;
end;

procedure Tfimpur.set_lambda(Sender: TObject);
//--------------------------------------------
const
  tab_wl:array[1..15] of string[10] =('0.70930','0.71359','0.63229',
                                      '1.54056','1.54439','1.39222',
                                      '1.78897','1.79285','1.62079',
                                      '1.93604','1.93339','1.75661',
                                      '2.28970','2.29361','2.08487');
  tab_anode:array[1..5] of string[2] =('Mo','Cu','Co','Fe','Cr');
var
  i: integer;
begin
  anode_calc:=tab_anode[listbox1.ItemIndex+1];
  i:=listbox1.ItemIndex*3+1;
  edit1.text:=tab_wl[i];
  edit2.text:=tab_wl[i+1];
  edit3.text:=tab_wl[i+2];
  edit5.text:='100';
  edit6.text:='50';
  edit7.text:='10';
end;

procedure Tfimpur.annule(Sender: TObject);
//----------------------------------------
begin
  fimpur.visible:=false;
end;

end.
