procedure equivalentes(var h1,k1,l1,h2,k2,l2,ier : integer);
//---------------------------------------------------------
 var
    i,j,k,n,m,ih,ik,il         : integer;
    car                        : char;
    tpos                       : array[1..24,1..3,1..3] of integer;
    ndeg                       : integer;
 const
    itc                  : array[1..54] of integer =
     (1, 0, 0,  0, 1, 0,  0, 0, 1,
      0, 1, 0,  0, 0, 1,  1, 0, 0,
      0, 0, 1,  1, 0, 0,  0, 1, 0,
      1, 0, 0,  0, 0, 1,  0, 1, 0,
      0, 1, 0,  1, 0, 0,  0, 0, 1,
      0, 0, 1,  0, 1, 0,  1, 0, 0);

    itq                  : array[1..18] of integer =
      (1,0,0,  0,1,0,  0,0,1,
       0,1,0,  1,0,0,   0,0,1);

    ith                  : array[1..18] of integer =
     ( 1, 0, 0,  0, 1, 0,  0, 0, 1,
       0, 1, 0,  1, 0, 0,  0, 0, 1);

    itr                  : array[1..54] of integer =
    (1,0,0, 0,1,0,  0,0,1,
     0,1,0, 0,0,1,  1,0,0,
     0,0,1, 1,0,0,  0,1,0,
     0,1,0, 1,0,0,  0,0,1,
     0,0,1, 0,1,0,  1,0,0,
     1,0,0,  0,0,1, 0,1,0);

    itm                  : array[1..18] of integer =
      (1,0,0,  0,1,0,  0,0,1,
      -1,0,0,  0,1,0,  0,0,-1);

 begin
    if (systeme = 'ORTH') or (systeme = 'TRIC')then exit;
    car:=systeme[1];
    if (systeme = 'TETR')then car:='Q';
    case car of
      'C': ndeg:=6;
      'Q': ndeg:=2;
      'H': ndeg:=2;
      'R': ndeg:=6;
      'M': ndeg:=2;
    end;

    n:=0;
    for k:=1 to ndeg do begin
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          n:=n+1;
          case car of
           'C': m:=itc[n];
           'Q': m:=itq[n];
           'H': m:=ith[n];
           'R': m:=itr[n];
           'M': m:=itm[n];
          end;
          tpos[k,i,j]:=m;
        end;
      end;
    end;
    for k:=2 to ndeg do begin
      ih:=round(tpos[k,1,1]*h2+tpos[k,1,2]*k2+tpos[k,1,3]*l2);
      ik:=round(tpos[k,2,1]*h2+tpos[k,2,2]*k2+tpos[k,2,3]*l2);
      il:=round(tpos[k,3,1]*h2+tpos[k,3,2]*k2+tpos[k,3,3]*l2);
      if ((ih = h1) and (ik = k1) and (il = l1)) or
      ((ih = -h1) and (ik = -k1) and (il = -l1)) then begin
        ier:=1;
        exit;
      end;
    end;

end;

procedure indx;{
---------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier,ih,ik,il,n,m         : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,d                                  : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^reflection;
  groupe                                               : array[1..48] of reflection;
  buf                                                  : reflection;
  xlp,theta_rad,echel,xx                               : real;
  r1,r2,r3                                             : real;
  tphkl                                                : tab_it;
  npos_hkl                                             : integer;
  nomf  : textfile;
label 1;
begin

//Tableau des equivalents hkl 10/07/02
  n:=0;
  if (nb_translation > 0)then m:=npos div nb_translation else m:=npos;
  for i:=1 to m do begin
      n:=n+1;
      for j:=1 to 3 do
      for k:=1 to 3 do tphkl[n,j,k]:=round(tp[i,j,k]);
  end;
  npos_hkl:=n ;
  if (centre = false)then begin
    for i:=1 to npos_hkl do begin
      for j:=1 to 3 do
      for k:=1 to 3 do tphkl[i+npos_hkl,j,k]:=-tphkl[i,j,k];
    end;
    npos_hkl:=2*npos_hkl;
  end;

  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'HEXA')then bravais:='P';

//limites des boucles
  setmat;
  xx:=2*sin(theta_max_depart/(57.2957*2))/lambda;

//22 mai 20002: Nouveau calcul des limites d'indices (voir Cranswick)
  h:=1;
  h2:=0;
  for k:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= h2)then h2:=i;
    end;
  end;

  k:=1;
  k2:=0;
  for h:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= k2)then k2:=i;
    end;
  end;

  l:=1;
  l2:=0;
  for h:=0 to 1 do begin
    for k:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= l2)then l2:=i;
    end;
  end;

  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raie:=0;
  if (systeme = 'CUBI')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=k to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);

          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TETR')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'ORTH')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'HEXA')then begin
    for h:=0 to h2 do begin
      for k:=h to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'RHOM')then begin
    for h:=0 to h2 do begin
      for k:=h to h2 do begin
        for l:=-h2 to h2 do begin
          if (h = 0) and (k = 0)  and (l = 0) then continue;
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'MONO')then begin
    for h:=h2 downto -h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TRIC')then begin
    for h:=-h2 to h2 do begin
      for k:=-k2 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  assignfile(nomf,'espion.txt');
  rewrite(nomf);

//Mise en ordre
  for i:=1 to nb_raie-1 do begin
    for j:=i+1 to nb_raie do begin
      if (result[i]^.dhkl < result[j]^.dhkl) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

//Dtection des raies gnres quivalentes
  for i:=1 to nb_raie-1 do begin
    for j:=i+1 to nb_raie do begin
      if (result[j]^.dhkl = 0) then continue;
      if (abs(result[i]^.dhkl-result[j]^.dhkl) < 0.0001)then begin
        with result[i]^ do begin
          h1:=h;
          k1:=k;
          l1:=l;
        end;
        with result[j]^ do begin
          h2:=h;
          k2:=k;
          l2:=l;
        end;
        ier:=0;
        equivalentes (h1,k1,l1,h2,k2,l2,ier);
        if (ier = 1) then begin
           result[j]^.dhkl:=0;
           continue;
        end;
      end;
    end;
  end;

//Elimination des raies si dhkl=0
  n:=0;
  for i:=1 to nb_raie do begin
      if (result[i]^.dhkl = 0)then continue;
      n:=n+1;
      result[n]^:=result[i]^;
  end;
  nb_raie:=n;

(*  for i:=1 to npos_hkl do begin
    for j:=1 to 3 do begin
      for k:=1 to 3 do write(nomf,tphkl[i,j,k]:5);
      writeln(nomf);
    end;
    writeln(nomf);
  end;
  writeln(nomf); *)

//Calcul de la multiplicit
  for i:=1 to nb_raie do begin
    with result[i]^ do begin
      h2:=h;
      k2:=k;
      l2:=l;
    end;
//  writeln(nomf,h2:3,k2:3,l2:3);
    for k:=1 to npos_hkl do begin
      groupe[k].h:=tphkl[k,1,1]*h2+tphkl[k,2,1]*k2+tphkl[k,3,1]*l2;
      groupe[k].k:=tphkl[k,1,2]*h2+tphkl[k,2,2]*k2+tphkl[k,3,2]*l2;
      groupe[k].l:=tphkl[k,1,3]*h2+tphkl[k,2,3]*k2+tphkl[k,3,3]*l2;
//    write(nomf,groupe[k].h:3,groupe[k].k:3,groupe[k].l:3,'  ');
    end;
//  writeln(nomf);
    for j:=1 to npos_hkl-1 do begin
      if (groupe[j].h = 0) and (groupe[j].k = 0) and (groupe[j].l =0) then continue;
      for k:= j+1 to npos_hkl do begin
        if (groupe[k].h = 0) and (groupe[k].k = 0) and (groupe[k].l =0) then continue;
        if (groupe[j].h = groupe[k].h) and
           (groupe[j].k = groupe[k].k) and
           (groupe[j].l = groupe[k].l) then begin
           groupe[k].h:=0;groupe[k].k:=0;groupe[k].l:=0;
        end;
      end;
    end;
    n:=0;
    for j:=1 to npos_hkl do begin
      if (groupe[j].h = 0) and (groupe[j].k = 0) and (groupe[j].l =0) then continue;
//    write(nomf,groupe[j].h:3,groupe[j].k:3,groupe[j].l:3,'  ');
      n:=n+1
    end;
//  writeln(nomf);

//  writeln(nomf);
    result[i]^.mult:=n;
    raies_part[i]:=result[i]^;
    raies_part[i].dtheta:=114.591559*arcsin(lambda/(2*raies_part[i].dhkl));
    dispose(result[i]);
  end;

// writeln(nomf);

//Ecriture provisoire
  for i:=1 to nb_raie do begin
    with raies_part[i] do writeln(nomf,i:5,h:4,k:4,l:4,dhkl:8:4,dtheta:8:4,mult:5);
  end;
  closefile(nomf);

end;

