procedure equivalentes(var npos_hkl:integer; tphkl :tab_it; h1,k1,l1,h2,k2,l2,ier : integer);
//-------------------------------------------------------------------------------------------
 var
    i,j,k,n,m,ih,ik,il         : integer;
begin
    for k:=2 to npos_hkl do begin
      ih:=tphkl[k,1,1]*h2+tphkl[k,2,1]*k2+tphkl[k,3,1]*l2;
      ik:=tphkl[k,1,2]*h2+tphkl[k,2,2]*k2+tphkl[k,3,2]*l2;
      il:=tphkl[k,1,3]*h2+tphkl[k,2,3]*k2+tphkl[k,3,3]*l2;
      if ((ih = h1) and (ik = k1) and (il = l1)) or
      ((ih = -h1) and (ik = -k1) and (il = -l1)) then begin
        ier:=1;
        exit;
      end;
    end;
end;

procedure indx;{
---------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier,ih,ik,il,n           : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,d                                  : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^reflection;
  buf                                                  : reflection;
  xlp,theta_rad,echel,xx                               : real;
  r1,r2,r3                                             : real;
  tphkl                                                : tab_it;
  npos_hkl                                             : integer;
  nomf  : textfile;
label 1;
begin
  n:=0;
  for i:=1 to npos do begin
    if (tp[i,1,4] <> 0) or (tp[i,2,4] <> 0) or (tp[i,3,4] <> 0) then continue;
    n:=n+1;
    for j:=1 to 3 do
    for k:=1 to 3 do tphkl[n,j,k]:=round(tp[i,j,k]);
  end;
  npos_hkl:=n ;
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'HEXA')then bravais:='P';

//limites des boucles
  setmat;
  xx:=2*sin(theta_max_depart/(57.2957*2))/lambda;

//22 mai 20002: Nouveau calcul des limites d'indices (voir Cranswick)
  h:=1;
  h2:=0;
  for k:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= h2)then h2:=i;
    end;
  end;

  k:=1;
  k2:=0;
  for h:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= k2)then k2:=i;
    end;
  end;

  l:=1;
  l2:=0;
  for h:=0 to 1 do begin
    for k:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= l2)then l2:=i;
    end;
  end;

  h1:=-h2;
  k1:=-k2;
  l1:=0;
  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raie:=0;
  for h:=-h2 to h2 do begin
    for k:=-k2 to k2 do begin
        for l:=-l2 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);

          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
    end;
  end;

  assignfile(nomf,'espion.txt');
  rewrite(nomf);
//Mise en ordre
  for i:=1 to nb_raie-1 do begin
    for j:=i+1 to nb_raie do begin
      if (result[i]^.dhkl < result[j]^.dhkl) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

//Indices prsents 2 fois
  for i:=1 to nb_raie-1 do begin
    if (result[i]^.dhkl = 0)then continue;
    for j:=i+1 to nb_raie do begin
      if (result[i]^.h = result[j].h) and (result[i]^.k = result[j].k) and
      (result[i]^.l = result[j].l)then result[j].dhkl:= 0;
    end;
  end;
  n:=0;
  for i:=1 to nb_raie do begin
    if (result[i]^.dhkl <> 0)then begin
      n:=n+1;
      result[n]^:=result[i]^;
      with result[n]^ do writeln(nomf,n:5,h:4,k:4,l:4,dhkl:8:4);
    end;
  end;
  writeln(nomf);
  for i:=1 to npos_hkl do begin
    for j:=1 to 3 do begin
      for k:=1 to 3 do write(nomf,tphkl[i,j,k]:5);
      writeln(nomf);
    end;
    writeln(nomf);
  end;
  writeln(nomf);

//Dtection des raies quivalentes
  for i:=1 to nb_raie do result[i]^.mult:=1;

  for i:=1 to nb_raie-1 do begin
    if (result[i]^.dhkl = 0) then continue;
    with result[i]^ do begin
      h1:=h;
      k1:=k;
      l1:=l;
    end;
    for j:=i+1 to nb_raie do begin
      if (result[j]^.dhkl = 0) then continue;
      if (abs(result[i]^.dhkl-result[j]^.dhkl) < 0.001)then begin
    (*     result[i]^.mult:=result[i]^.mult+1;
         result[j]^.dhkl:=0;
      end; *)

       with result[j]^ do begin
          h2:=h;
          k2:=k;
          l2:=l;
        end;

//equivalentes
        ier:=0;
        for k:=2 to npos_hkl do begin
          ih:=tphkl[k,1,1]*h2+tphkl[k,2,1]*k2+tphkl[k,3,1]*l2;
          ik:=tphkl[k,1,2]*h2+tphkl[k,2,2]*k2+tphkl[k,3,2]*l2;
          il:=tphkl[k,1,3]*h2+tphkl[k,2,3]*k2+tphkl[k,3,3]*l2;
          if ((ih = h1) and (ik = k1) and (il = l1)) then begin
            result[i]^.mult:=result[i]^.mult+1;
            result[j]^.dhkl:=0;
//          break;
          end;
        end;
//      equivalentes (npos_hkl,tphkl,h1,k1,l1,h2,k2,l2,ier);
      end;

    end;
  end;

//Elimination des raies doubles
  n:=0;
  for i:=1 to nb_raie do begin
      if (result[i]^.dhkl <> 0)then begin;
        n:=n+1;
        raies_part[n]:=result[i]^;
        raies_part[n].dtheta:=114.591559*arcsin(lambda/(2*raies_part[n].dhkl));
      end;
      dispose(result[i]);
  end;
  nb_raie:=n;

//Ecriture provisoire
  for i:=1 to nb_raie do begin
    with raies_part[i] do writeln(nomf,i:5,h:4,k:4,l:4,dhkl:8:4,dtheta:8:4,mult:5);
  end;
  closefile(nomf);

end;

