{Calcul du profil}
procedure calc_profil(fmelange,wl,theta_milieu,largeur,intensite : real);
//----------------------------------------------------------------------
var
i                     : integer;
x,y                   : real;
begin
  for i:=1 to 1015 do begin
      x_pro[i]:=theta_min+pas*(i-1);
      x:=(x_pro[i]-theta_milieu)/largeur;
      {Voigt I}
      y:=fmelange*(1/(1+x*x))+(1-fmelange)*power(2,(-x*x));
      y_pro[i]:=y_pro[i]+intensite*y;
  end;
end;

procedure effacement_spectre_res;
//------------------------------
// effacement de l'image et des rsultats;
begin
  with fmain do begin
    fmain.listbox3.clear;
    efface_image;
  end;
end;

procedure recalcule_echelle_raw;
//------------------------------
 var
   i           : integer;
   ech         : real;
 begin
    if(nb_raie_raw = 0)then exit;
    ymax:=0;
    for i:=1 to nb_raie_raw do begin
      if (x_raw[i] < theta_min) or (x_raw[i] > theta_max)then continue;
      if (y_raw[i] > ymax) then ymax:=y_raw[i];
    end;
    ech:=100/ymax;
    for i:=1 to nb_raie_raw do y_raw[i]:=y_raw[i]*ech;
 end;

procedure ecrit_listbox3;
//-----------------------
var
  i          : integer;
  s,s1,s2,s3 : string;
  x          : real;
begin
  fmain.listbox3.color:=$FFE4BD;
  fmain.listbox3.clear;
  case fmain.radiogroup1.ItemIndex of
    0:  s:=' Nb. h  k  l   Dhkl   Theta   Int. lambda';
    1:  s:=' Nb. h  k  l   Dhkl  2Theta   Int. lambda';
    2:  s:=' NB. h  k  l   Dhkl     Q       Int. ';
  end;
  fmain.Listbox3.items.add(s);
  s:='_________________________________________________';
  fmain.Listbox3.items.add(s);

  if (fmain.radiogroup1.ItemIndex <> 2)then begin
    for i:=1 to nb_raie_tot do  begin
      str(i:3,s);
      str(raies_tot[i].h:3,s1);
      str(raies_tot[i].k:3,s2);
      str(raies_tot[i].l:3,s3);
      s:=s+s1+s2+s3;
      str(raies_tot[i].dhkl:8:4,s1);
      s:=s+s1;
      x:=raies_tot[i].dtheta;
      if (fmain.RadioGroup1.ItemIndex = 0)then x:=x/2;
      str(x:8:3,s1);
      s:=s+s1;
      str(raies_tot[i].int:6:0,s1);
      s:=s+s1;
      str(raies_tot[i].wl:8:5,s1);
      s:=s+s1;
      fmain.Listbox3.items.add(s);
    end;
  end else begin
    for i:=1 to nb_raie do  begin
      str(i:3,s);
      str(q_tot[i].h:3,s1);
      str(q_tot[i].k:3,s2);
      str(q_tot[i].l:3,s3);
      s:=s+s1+s2+s3;
      str(2*pi/q_tot[i].q:8:4,s1);
      s:=s+s1;
      str(q_tot[i].q:8:4,s1);
      s:=s+s1;
      str(q_tot[i].int:8:0,s1);
      s:=s+s1;
      fmain.Listbox3.items.add(s);
    end;
  end;
end;

procedure licromer(var no_element,ier:integer);
//--------------------------------------------
 const
   elem_crom: array[1..213] of string[4]=(
'H   ','H.  ','H1- ','He  ','Li  ','Li1+','Be  ','Be2+',
'B   ','C   ','C.  ','N   ','O   ','O1- ','O2-.','F   ',
'F1- ','Ne  ','Na  ','Na1+','Mg  ','Mg2+','Al  ','Al3+',
'Si  ','Si. ','Si4+','S   ','P   ','Cl  ','Cl1-','Ar  ',
'K   ','K1+ ','Ca  ','Ca2+','Sc  ','Sc3+','Ti  ','Ti2+',
'Ti3+','Ti4+','V   ','V2+ ','V3+ ','V5+ ','Cr  ','Cr2+',
'Cr3+','Mn  ','Mn2+','Mn3+','Mn4+','Fe  ','Fe2+','Fe3+',
'Co  ','Co2+','Co3+','Ni  ','Ni2+','Ni3+','Cu  ','Cu1+',
'Cu2+','Zn  ','Zn2+','Ga  ','Ga3+','Ge  ','Ge4+','As  ',
'Se  ','Br  ','Br1-','Kr  ','Rb  ','Rb1+','Sr  ','Sr2+',
'Y   ','Y3+ ','Zr  ','Zr4+','Nb  ','Nb3+','Nb5+','Mo  ',
'Mo3+','Mo5+','Mo6+','Tc  ','Ru  ','Ru3+','Ru+4','Rh  ',
'Rh3+','Rh4+','Pd  ','Pd2+','Pd4+','Ag  ','Ag1+','Ag2+',
'Cd  ','Cd2+','In  ','In3+','Sn  ','Sn2+','Sn4+','Sb  ',
'Sb3+','Sb5+','Te  ','I   ','I1- ','Xe  ','Cs  ','Cs1+',
'Ba  ','Ba2+','La  ','La3+','Ce  ','Ce3+','Ce4+','Pr  ',
'Pr3+','Pr4+','Nd  ','Nd3+','Pm  ','Pm3+','Sm  ','Sm3+',
'Eu  ','Eu2+','Eu3+','Gd  ','Gd3+','Tb  ','Tb3+','Dy  ',
'Dy3+','Ho  ','Ho3+','Er  ','Er3+','Tm  ','Tm3+','Yb  ',
'Yb2+','Yb3+','Lu  ','Lu3+','Hf  ','Hf4+','Ta  ','Ta5+',
'W   ','W6+ ','Re  ','Os  ','Os4+','Ir  ','Ir3+','Ir4+',
'Pt  ','Pt2+','Pt4+','Au  ','Au1+','Au3+','Hg  ','Hg1+',
'Hg2+','Tl  ','Tl1+','Tl3+','Pb  ','Pb2+','Pb4+','Bi  ',
'Bi3+','Bi5+','Po  ','At  ','Rn  ','Fr  ','Ra  ','Ra2+',
'Ac  ','Ac3+','Th  ','Th4+','Pa  ','U   ','U3+ ','U4+ ',
'U6+ ','Np  ','Np3+','Np4+','Np6+','Pu  ','Pu3+','Pu4+',
'Pu6+','Am  ','Cm  ','Bk  ','Cf  ');
   tab_crom:array[1..1917] of real =(
   0.49300,   0.32291,   0.14019,   0.04081,   0.00304,  10.51090,  26.12570,
   3.14236,  57.79970,   0.48992,   0.26200,   0.19677,   0.04988,   0.00131,
  20.65930,   7.74039,  49.55190,   2.20159,   0.89766,   0.56562,   0.41581,
   0.11697,   0.00239,  53.13680,  15.18700, 186.57600,   3.56709,   0.87340,
   0.63090,   0.31120,   0.17800,   0.00640,   9.10370,   3.35680,  22.92760,
   0.98210,   1.12820,   0.75080,   0.61750,   0.46530,   0.03770,   3.95460,
   1.05240,  85.39050, 168.26100,   0.69680,   0.78880,   0.34140,   0.15630,
   0.01670,   4.62370,   1.95570,   0.63160,  10.09530,   1.59190,   1.12780,
   0.53910,   0.70290,   0.03850,  43.64270,   1.86230, 103.48300,   0.54200,
   6.26030,   0.88490,   0.79930,   0.16470,  -6.10920,   0.00270,   0.83130,
   2.27580,   5.11460,   2.05450,   1.33260,   1.09790,   0.70680,  -0.19320,
  23.21850,   1.02100,  60.34980,   0.14030,   2.31000,   1.02000,   1.58860,
   0.86500,   0.21560,  20.84390,  10.20750,   0.56870,  51.65120,   2.26069,
   1.56165,   1.05075,   0.83926,   0.28698,  22.69070,   0.65667,   9.75618,
  55.59490,  12.21260,   3.13220,   2.01250,   1.16630, -11.52900,   0.00570,
   9.89330,  28.99750,   0.58260,   3.04850,   2.28680,   1.54630,   0.86700,
   0.25080,  13.27710,   5.70110,   0.32390,  32.90890,   4.19160,   1.63969,
   1.52673, -20.30700,  21.94120,  12.85730,   4.17236,  47.01790,  -0.01404,
   4.75800,   3.63700,   0.00000,   0.00000,   1.59400,   7.83100,  30.05000,
   0.00000,   0.00000,   3.53920,   2.64120,   1.51700,   1.02430,   0.27760,
  10.28250,   4.29440,   0.26150,  26.14760,   3.63220,   3.51057,   1.26064,
   0.94071,   0.65340,   5.27756,  14.73530,   0.44226,  47.34370,   3.95530,
   3.11250,   1.45460,   1.12510,   0.35150,   8.40420,   3.42620,   0.23060,
  21.71840,   4.76260,   3.17360,   1.26740,   1.11280,   0.67600,   3.28500,
   8.84220,   0.31360, 129.42400,   3.25650,   3.93620,   1.39980,   1.00320,
   0.40400,   2.66710,   6.11530,   0.20010,  14.03900,   5.42040,   2.17350,
   1.22690,   2.30730,   0.85840,   2.82750,  79.26110,   0.38080,   7.19370,
   3.49880,   3.83780,   1.32840,   0.84970,   0.48530,   2.16760,   4.75420,
   0.18500,  10.14110,   6.42020,   1.90020,   1.59360,   1.96460,   1.11510,
   3.03870,   0.74260,  31.54720,  85.08860,   4.17448,   3.38760,   1.20296,
   0.52814,   0.70679,   1.93816,   4.14553,   0.22875,   8.28524,   6.29150,
   3.03530,   1.98910,   1.54100,   1.14070,   2.43860,  32.33370,   0.67850,
  81.69370,   5.66269,   3.07164,   2.62446,   1.39320,   1.24707,   2.66520,
  38.66340,   0.91695,  93.54580,   4.43918,   3.20345,   1.19453,   0.41653,
   0.74630,   1.64167,   3.43757,   0.21490,   6.65365,   6.90530,   5.20340,
   1.43790,   1.58630,   0.86690,   1.46790,  22.21510,   0.25360,  56.17200,
   6.43450,   4.17910,   1.78000,   1.49080,   1.11490,   1.90670,  27.15700,
   0.52600,  68.16450,  11.46040,   7.19640,   6.25560,   1.64550,  -9.55740,
   0.01040,   1.16620,  18.51940,  47.77840,  18.29150,   7.20840,   6.53370,
   2.33860, -16.37800,   0.00660,   1.17170,  19.54240,  60.44860,   7.48450,
   6.77230,   0.65390,   1.64420,   1.44450,   0.90720,  14.84070,  43.89830,
  33.39290,   8.21860,   7.43980,   1.05190,   0.86590,   1.42280,  12.79490,
   0.77480, 213.18700,  41.68410,   7.95780,   7.49170,   6.35900,   1.19150,
  -4.99780,  12.63310,   0.76740,  -0.00200,  31.91280,   8.62660,   7.38730,
   1.58990,   1.02110,   1.37510,  10.44210,   0.65990,  85.74840, 178.43700,
  15.63480,   7.95180,   8.43720,   0.85370, -14.87500,  -0.00740,   0.60890,
  10.31160,  25.99050,   9.18900,   7.36790,   1.64090,   1.46800,   1.33290,
   9.02130,   0.57290, 136.10800,  51.35310,  13.40080,   8.02730,   1.65943,
   1.57936,  -6.66670,   0.29854,   7.96290,  -0.28604,  16.06620,   9.75950,
   7.35580,   1.69910,   1.90210,   1.28070,   7.85080,   0.50000,  35.63380,
 116.10500,   9.11423,   7.62174,   2.27930,   0.08790,   0.89715,   7.52430,
   0.45759,  19.53610,  61.65580,  17.73440,   8.73816,   5.25691,   1.92134,
 -14.65200,   0.22061,   7.04716,  -0.15762,  15.97680,  19.51140,   8.23473,
   2.01341,   1.52080, -13.28000,   0.17885,   6.67018,  -0.29263,  12.94640,
  10.29710,   7.35110,   2.07030,   2.05710,   1.21990,   6.86570,   0.43850,
  26.89380, 102.47800,  10.10600,   7.35410,   2.28840,   0.02230,   1.22980,
   6.88180,   0.44090,  20.30040, 115.12200,   9.43141,   7.74190,   2.15343,
   0.01687,   0.65657,   6.39535,   0.38335,  15.19080,  63.96900,  15.68870,
   8.14208,   2.03081,  -9.57600,   1.71430,   0.67900,   5.40135,   9.97278,
   0.94046,  10.64060,   7.35370,   3.32400,   1.49220,   1.18320,   6.10380,
   0.39200,  20.26260,  98.73990,   9.54034,   7.75090,   3.58274,   0.50911,
   0.61690,   5.66078,   0.34426,  13.30750,  32.42240,   9.68090,   7.81136,
   2.87603,   0.11357,   0.51828,   5.59463,   0.33439,  12.82880,  32.87610,
  11.28190,   7.35730,   3.01930,   2.24410,   1.08960,   5.34090,   0.34320,
  17.86740,  83.75430,  10.80610,   7.36200,   3.52680,   0.21840,   1.08740,
   5.27960,   0.34350,  14.34300,  41.32350,   9.84521,   7.87194,   3.56531,
   0.32361,   0.39397,   4.91797,   0.29439,  10.81710,  24.12810,   9.96253,
   7.97057,   2.76067,   0.05445,   0.25188,   4.84850,   0.28330,  10.48520,
  27.57300,  11.76950,   7.35730,   3.52220,   2.30450,   1.03690,   4.76110,
   0.30720,  15.35350,  76.88050,  11.04240,   7.37400,   4.13460,   0.43990,
   1.00970,   4.65380,   0.30530,  12.05460,  31.28090,  11.17640,   7.38630,
   3.39480,   0.07240,   0.97070,   4.61470,   0.30050,  11.67290,  38.55660,
  12.28410,   7.34090,   4.00340,   2.34880,   1.01180,   4.27910,   0.27840,
  13.53590,  71.16920,  11.22960,   7.38830,   4.73930,   0.71080,   0.93240,
   4.12310,   0.27260,  10.24430,  25.64660,  10.33800,   7.88173,   4.76795,
   0.72559,   0.28667,   3.90969,   0.23867,   8.35583,  18.34910,  12.83760,
   7.29200,   4.44380,   2.38000,   1.03410,   3.87850,   0.25650,  12.17630,
  66.34210,  11.41660,   7.40050,   5.34420,   0.97730,   0.86140,   3.67660,
   0.24490,   8.87300,  22.16260,  10.78060,   7.75868,   5.22746,   0.84711,
   0.38604,   3.54770,   0.22314,   7.64468,  16.96730,  13.33800,   7.16760,
   5.61580,   1.67350,   1.19100,   3.58280,   0.24700,  11.39660,  64.81260,
  11.94750,   7.35730,   6.24550,   1.55780,   0.89000,   3.36690,   0.22740,
   8.66250,  25.84870,  11.81680,   7.11181,   5.78135,   1.14523,   1.14431,
   3.37484,   0.24408,   7.98760,  19.89700,  14.07430,   7.03180,   5.16520,
   2.41000,   1.30410,   3.26550,   0.23330,  10.31630,  58.70970,  11.97190,
   7.38620,   6.46680,   1.39400,   0.78070,   2.99460,   0.20310,   7.08260,
  18.09950,  15.23540,   6.70060,   4.35910,   2.96230,   1.71890,   3.06690,
   0.24120,  10.78050,  61.41350,  12.69200,   6.69883,   6.06692,   1.00660,
   1.53545,   2.81262,   0.22789,   6.36441,  14.41220,  16.08160,   6.37470,
   3.70680,   3.68300,   2.13130,   2.85090,   0.25160,  11.44680,  54.76250,
  12.91720,   6.70003,   6.06791,   0.85904,   1.45572,   2.53718,   0.20585,
   5.47913,  11.60300,  16.67230,   6.07010,   3.43130,   4.27790,   2.53100,
   2.63450,   0.26470,  12.94790,  47.79720,  17.00060,   5.81960,   3.97310,
   4.35430,   2.84090,   2.40980,   0.27260,  15.23720,  43.81630,  17.17890,
   5.23580,   5.63770,   3.98510,   2.95570,   2.17230,  16.57960,   0.26090,
  41.43280,  17.17180,   6.33380,   5.57540,   3.72720,   3.17760,   2.20590,
  19.33450,   0.28710,  58.15350,  17.35550,   6.72860,   5.54930,   3.53750,
   2.82500,   1.93840,  16.56230,   0.22610,  39.39720,  17.17840,   9.64350,
   5.13990,   1.52920,   3.48730,   1.78880,  17.31510,   0.27480, 164.93400,
  17.58160,   7.65980,   5.89810,   2.78170,   2.07820,   1.71390,  14.79570,
   0.16030,  31.20870,  17.56630,   9.81840,   5.42200,   2.66940,   2.50640,
   1.55640,  14.09880,   0.16640, 132.37600,  18.08740,   8.13730,   2.56540,
 -34.19300,  41.40250,   1.49070,  12.69630,  24.56510,  -0.01380,  17.77600,
  10.29460,   5.72629,   3.26588,   1.91213,   1.40290,  12.80060,   0.12560,
 104.35400,  17.92680,   9.15310,   1.76795, -33.10800,  40.26020,   1.35417,
  11.21450,  22.65990,  -0.01319,  17.87650,  10.94800,   5.41732,   3.65721,
   2.06929,   1.27618,  11.91600,   0.11762,  87.66270,  18.16680,  10.05620,
   1.01118,  -2.64790,   9.41454,   1.21480,  10.14830,  21.60540,  -0.10276,
  17.61420,  12.01440,   4.04183,   3.53346,   3.75591,   1.18865,  11.76600,
   0.20479,  69.79570,  19.88120,  18.06530,  11.01770,   1.94715, -12.91200,
   0.01918,   1.13305,  10.16210,  28.33890,  17.91630,  13.34170,  10.79900,
   0.33790,  -6.39340,   1.12446,   0.02878,   9.28206,  25.72280,   3.70250,
  17.23560,  12.88760,   3.74290,   4.38750,   0.27720,   1.09580,  11.00400,
  61.65840,  21.16640,  18.20170,  11.74230,   2.30951, -14.42100,   0.01473,
   1.03031,   9.53659,  26.63070,  21.01490,  18.09920,  11.46320,   0.74063,
 -14.31600,   0.01434,   1.02238,   8.78809,  23.34520,  17.88710,  11.17500,
   6.57891,   0.00000,   0.34494,   1.03649,   8.48061,   0.05888,   0.00000,
  19.13010,  11.09480,   4.64901,   2.71263,   5.40428,   0.86413,   8.14487,
  21.57070,  86.84720,  19.26740,  12.91820,   4.86337,   1.56756,   5.37874,
   0.80852,   8.43467,  24.79970,  94.29280,  18.56380,  13.28850,   9.32602,
   3.00964,  -3.18920,   0.84733,   8.37164,   0.01766,  22.88700,  18.50030,
  13.17870,   4.71304,   2.18535,   1.42357,   0.84458,   8.12534,   0.03650,
  20.85040,  19.29570,  14.35010,   4.73425,   1.28918,   5.32800,   0.75154,
   8.21758,  25.87490,  98.60620,  18.87850,  14.12590,   3.32515,  -6.19890,
  11.86780,   0.76425,   7.84438,  21.24870,  -0.01036,  18.85450,  13.98060,
   2.53464,  -5.65260,  11.28350,   0.76082,   7.62436,  19.33170,  -0.01020,
  19.33190,  15.50170,   5.29537,   0.60584,   5.26593,   0.69866,   7.98929,
  25.20520,  76.89860,  19.17010,  15.20960,   4.32234,   0.00000,   5.29160,
   0.69622,   7.55573,  22.50570,   0.00000,  19.24930,  14.79000,   2.89289,
  -7.94920,  13.01740,   0.68384,   7.14833,  17.91440,   0.00513,  19.28080,
  16.68850,   4.80450,   1.04630,   5.17900,   0.64460,   7.47260,  24.66050,
  99.81560,  19.18120,  15.97190,   5.27475,   0.35753,   5.21572,   0.64618,
   7.19123,  21.73260,  66.11470,  19.16430,  16.24560,   4.37090,   0.00000,
   5.21404,   0.64564,   7.18544,  21.40720,   0.00000,  19.22140,  17.64440,
   4.46100,   1.60290,   5.06940,   0.59460,   6.90890,  24.70080,  87.48250,
  19.15140,  17.25350,   4.47128,   0.00000,   5.11937,   0.59792,   6.80639,
  20.25210,   0.00000,  19.16240,  18.55960,   4.29480,   2.03960,   4.93910,
   0.54760,   6.37760,  25.84990,  92.80290,  19.10450,  18.11080,   3.78897,
   0.00000,   4.99635,   0.55152,   6.32470,  17.35950,   0.00000,  19.18890,
  19.10050,   4.45850,   2.46630,   4.78210,   5.83030,   0.50310,  26.89090,
  83.95710,  19.10940,  19.05480,   4.56480,   0.48700,   4.78610,   0.50360,
   5.83780,  23.37520,  62.20610,  18.93330,  19.71310,   3.41820,   0.01930,
   3.91820,   5.76400,   0.46550,  14.00490,  -0.75830,  19.64180,  19.04550,
   5.03710,   2.68270,   4.59090,   5.30340,   0.46070,  27.90740,  75.28250,
  18.97550,  18.93300,   5.10789,   0.28875,   4.69626,   0.46720,   5.22126,
  19.59020,  55.51130,  19.86850,  19.03020,   2.41253,   0.00000,   4.69263,
   5.44853,   0.46797,  14.12590,   0.00000,  19.96440,  19.01380,   6.14487,
   2.52390,   4.35200,   4.81742,   0.42088,  28.52840,  70.84030,  20.14720,
  18.99490,   7.51380,   2.27350,   4.07120,   4.34700,   0.38140,  27.76600,
  66.87760,  20.23320,  18.99700,   7.80690,   2.88680,   4.07140,   4.35790,
   0.38150,  29.52590,  84.93040,  20.29330,  19.02980,   8.97670,   1.99000,
   3.71180,   3.92820,   0.34400,  26.46590,  64.26580,  20.38920,  19.10620,
  10.66200,   1.49530,   3.33520,   3.56900,   0.31070,  24.38790, 213.90400,
  20.35240,  19.12780,  10.28210,   0.96150,   3.27910,   3.55200,   0.30860,
  23.71280,  59.45650,  20.33610,  19.29700,  10.88800,   2.69590,   2.77310,
   3.21600,   0.27560,  20.20730, 167.20200,  20.18070,  19.11360,  10.90540,
   0.77363,   3.02902,   3.21367,   0.28331,  20.05580,  51.74600,  20.57800,
  19.59900,  11.37270,   3.28719,   2.14678,   2.94817,   0.24448,  18.77260,
 133.12400,  20.24890,  19.37630,  11.63230,   0.33605,   2.40860,   2.92070,
   0.25070,  17.82110,  54.94530,  21.16710,  19.76950,  11.85130,   3.33049,
   1.86264,   2.81219,   0.22684,  17.60830, 127.11300,  20.80360,  19.55900,
  11.93690,   0.61238,   2.09013,   2.77691,   0.23154,  16.54080,  43.16920,
  20.32350,  19.81860,  12.12330,   0.14458,   1.59180,   2.65941,   0.21885,
  15.79920,  62.23550,  22.04400,  19.66970,  12.38560,   2.82428,   2.05830,
   2.77393,   0.22209,  16.76690, 143.64400,  21.37270,  19.74910,  12.13290,
   0.97518,   1.77132,   2.64520,   0.21430,  15.32300,  36.40650,  20.94130,
  20.05390,  12.46680,   0.29669,   1.24285,   2.54467,   0.20248,  14.81370,
  45.46430,  22.68450,  19.68470,  12.77400,   2.85137,   1.98486,   2.66248,
   0.21063,  15.88500, 137.90300,  21.96100,  19.93390,  12.12000,   1.51031,
   1.47588,   2.52722,   0.19924,  14.17830,  30.87170,  23.34050,  19.60950,
  13.12350,   2.87516,   2.02876,   2.56270,   0.20209,  15.10090, 132.72100,
  22.55270,  20.11080,  12.06710,   2.07492,   1.19499,   2.41740,   0.18577,
  13.12750,  27.44910,  24.00420,  19.42580,  13.43960,   2.89604,   2.20963,
   2.47274,   0.19645,  14.39960, 128.00700,  23.15040,  20.25990,  11.92020,
   2.71488,   0.95459,   2.31641,   0.17408,  12.15710,  24.82420,  24.62740,
  19.08860,  13.76030,   2.92270,   2.57450,   2.38790,   0.19420,  13.75460,
 123.17400,  24.00630,  19.95040,  11.80340,   3.87243,   1.36389,   2.27783,
   0.17353,  11.60960,  26.51560,  23.74970,  20.37450,  11.85090,   3.26503,
   0.75934,   2.22258,   0.16394,  11.31100,  22.99660,  25.07090,  19.07980,
  13.85180,   3.54545,   2.41960,   2.25341,   0.18195,  12.93310, 101.39800,
  24.34660,  20.42080,  11.87080,   3.71490,   0.64509,   2.13553,   0.15552,
  10.57820,  21.70290,  25.89760,  18.21850,  14.31670,   2.95354,   3.58324,
   2.24256,   0.19614,  12.66480, 115.36200,  24.95590,  20.32710,  12.24710,
   3.77300,   0.69197,   2.05601,   0.14953,  10.04990,  21.27730,  26.50700,
  17.63830,  14.55960,   2.96577,   4.29728,   2.18020,   0.20217,  12.18990,
 111.87400,  25.53950,  20.28610,  11.98120,   4.50073,   0.68969,   1.98040,
   0.14338,   9.34972,  19.58100,  26.90490,  17.29400,  14.55830,   3.63837,
   4.56796,   2.07051,   0.19794,  11.44070,  92.65660,  26.12960,  20.09940,
  11.97880,   4.93676,   0.85280,   1.91072,   0.13936,   8.80018,  18.59080,
  27.65630,  16.42850,  14.97790,   2.98233,   5.92046,   2.07356,   0.22354,
  11.36040, 105.70300,  26.72200,  19.77480,  12.15060,   5.17379,   1.17613,
   1.84659,   0.13729,   8.36225,  17.89740,  28.18190,  15.88510,  15.15420,
   2.98706,   6.75621,   2.02859,   0.23885,  10.99750, 102.96100,  27.30830,
  19.33200,  12.33390,   5.38348,   1.63929,   1.78711,   0.13697,   7.96778,
  17.29220,  28.66410,  15.43450,  15.30870,   2.98963,   7.56672,   1.98890,
   0.25712,  10.66470, 100.41700,  28.12090,  17.68170,  13.33350,   5.14657,
   3.70983,   1.78503,   0.15997,   8.18304,  20.39000,  27.89170,  18.76140,
  12.60720,   5.47647,   2.26001,   1.73272,   0.13879,   7.64412,  16.81530,
  28.94760,  15.22080,  15.10000,   3.71601,   7.97628,   1.90182,   9.98519,
   0.26103,  84.32980,  28.46280,  18.12100,  12.84290,   5.59415,   2.97573,
   1.68216,   0.14229,   7.33727,  16.35350,  29.14400,  15.17260,  14.75860,
   4.30013,   8.58154,   1.83262,   9.59990,   0.27512,  72.02900,  28.81310,
  18.46010,  12.72850,   5.59927,   2.39699,   1.59136,   0.12890,   6.76232,
  14.03660,  29.20240,  15.22930,  14.51350,   4.76492,   9.24354,   1.77333,
   9.37046,   0.29598,  63.36440,  29.15870,  18.84070,  12.82680,   5.38695,
   1.78555,   1.50711,   0.11674,   6.31524,  12.42440,  29.08180,  15.43000,
  14.43270,   5.11982,   9.88750,   1.72029,   9.22590,   0.32170,  57.05600,
  29.49360,  19.37630,  13.05440,   5.06412,   1.01074,   1.42755,   0.10462,
   5.93667,  11.19720,  28.76210,  15.71890,  14.55640,   5.44174,  10.47200,
   1.67191,   9.09227,   0.35050,  52.08610,  28.18940,  16.15500,  14.93050,
   5.67589,  11.00050,   1.62903,   8.97948,   0.38266,  48.16470,  30.41900,
  15.26370,  14.74580,   5.06795,   6.49804,   1.37113,   6.84706,   0.16519,
  18.00300,  27.30490,  16.72960,  15.61150,   5.83377,  11.47220,   1.59279,
   8.86553,   0.41792,  45.00110,  30.41560,  15.86200,  13.61450,   5.82008,
   8.27903,   1.34323,   7.10909,   0.20463,  20.32540,  30.70580,  15.55120,
  14.23260,   5.53672,   6.96824,   1.30923,   6.71983,   0.16725,  17.49110,
  27.00590,  17.76390,  15.71310,   5.78370,  11.68830,   1.51293,   8.81174,
   0.42459,  38.61030,  29.84290,  16.72240,  13.21530,   6.35234,   9.85329,
   1.32927,   7.38979,   0.26330,  22.94260,  30.96120,  15.98290,  13.73480,
   5.92034,   7.39534,   1.24813,   6.60834,   0.16864,  16.93920,  16.88190,
  18.59130,  25.55820,   5.86000,  12.06580,   0.46110,   8.62160,   1.48260,
  36.39560,  28.01090,  17.82040,  14.33590,   6.58077,  11.22990,   1.35321,
   7.73950,   0.35675,  26.40430,  30.68860,  16.90290,  12.78010,   6.52354,
   9.09680,   1.21990,   6.82872,   0.21287,  18.65900,  20.68090,  19.04170,
  21.65750,   5.96760,  12.60890,   0.54500,   8.44840,   1.57290,  38.32460,
  25.08530,  18.49730,  16.88830,   6.48216,  12.02050,   1.39507,   7.65105,
   0.44338,  28.22620,  29.56410,  18.06000,  12.83740,   6.89912,  10.62680,
   1.21152,   7.05639,   0.28474,  20.74820,  27.54460,  19.15840,  15.53800,
   5.52593,  13.17460,   0.65515,   8.70751,   1.96347,  45.81490,  21.39850,
  20.47230,  18.74780,   6.82847,  12.52580,   1.47110,   0.51739,   7.43463,
  28.84820,  30.86950,  18.38410,  11.93280,   7.00574,   9.80270,   1.10080,
   6.53852,   0.21907,  17.21140,  31.06170,  13.06370,  18.44200,   5.96960,
  13.41180,   0.69020,   2.35760,   8.61800,  47.25790,  21.78860,  19.56820,
  19.14060,   7.01107,  12.47340,   1.33660,   0.48838,   6.77270,  23.81320,
  32.12440,  18.80030,  12.01750,   6.96886,   8.08428,   1.00566,   6.10926,
   0.14704,  14.71400,  33.36890,  12.95100,  16.58770,   6.46920,  13.57820,
   0.70400,   2.92380,   8.79370,  48.00930,  21.80530,  19.50260,  19.10530,
   7.10295,  12.47110,   1.23560,   6.24149,   0.47000,  20.31850,  33.53640,
  25.09460,  19.24970,   6.91555,  -6.79940,   0.91654,   0.03904,   5.71414,
  12.82850,  34.67260,  15.47330,  13.11380,   7.02588,  13.67700,   0.70100,
   3.55078,   9.55642,  47.00450,  35.31630,  19.02110,   9.49887,   7.42518,
  13.71080,   0.68587,   3.97458,  11.38240,  45.47150,  35.56310,  21.28160,
   8.00370,   7.44330,  13.69050,   0.66310,   4.06910,  14.04220,  44.24730,
  35.92990,  23.05470,  12.14390,   2.11253,  13.72470,   0.64645,   4.17619,
  23.10520, 150.64500,  35.76300,  22.90640,  12.47390,   3.21097,  13.62110,
   0.61634,   3.87135,  19.98870, 142.32500,  35.21500,  21.67000,   7.91342,
   7.65078,  13.54310,   0.60491,   3.57670,  12.60100,  29.84360,  35.65970,
  23.10320,  12.59770,   4.08655,  13.52660,   0.58909,   3.65155,  18.59900,
 117.02000,  35.17360,  22.11120,   8.19216,   7.05545,  13.46370,   0.57969,
   3.41437,  12.91870,  25.94430,  35.56450,  23.42190,  12.74730,   4.80703,
  13.43140,   0.56336,   3.46204,  17.83090,  99.17220,  35.10070,  22.44180,
   9.78554,   5.29444,  13.37600,   0.55505,   3.24498,  13.46610,  23.95330,
  35.88470,  23.29480,  14.18910,   4.17287,  13.42870,   0.54775,   3.41519,
  16.92350, 105.25100,  36.02280,  23.41280,  14.94910,   4.18800,  13.39660,
   0.52930,   3.32530,  16.09270, 100.61300,  35.57470,  22.52590,  12.21650,
   5.37073,  13.30920,   0.52048,   3.12293,  12.71480,  26.33940,  35.37150,
  22.53260,  12.02910,   4.79840,  13.26710,   0.51660,   3.05053,  12.57230,
  23.45820,  34.85090,  22.75840,  14.00990,   1.21457,  13.16650,   0.50708,
   2.89030,  13.17670,  25.20170,  36.18740,  23.59640,  15.64020,   4.18550,
  13.35730,   0.51193,   3.25396,  15.36220,  97.49080,  35.01360,  22.72860,
  14.38840,   1.75669,  13.11300,   0.48981,   2.81099,  12.33000,  22.65810,
  36.52540,  23.80830,  16.77070,   3.47947,  13.38120,   0.49938,   3.26371,
  14.94550, 105.98000,  35.70740,  22.61300,  12.98980,   5.43227,  13.25440,
   0.50232,   3.03807,  12.14490,  25.49280,  35.51030,  22.57870,  12.77660,
   4.92159,  13.21160,   0.49863,   2.96627,  11.94840,  22.75020,  35.84000,
  22.71690,  13.58070,   5.66016,  13.19910,   0.48494,   2.96118,  11.53310,
  24.39920,  35.64930,  22.64600,  13.35950,   5.18831,  13.15550,   0.48142,
   2.89020,  11.31600,  21.83010,  35.17360,  22.71810,  14.76350,   2.28678,
  13.05820,   0.47320,   2.73848,  11.55300,  20.93030,  36.67060,  24.09920,
  17.34150,   3.49331,  13.35920,   0.48363,   3.20647,  14.31360, 102.27300,
  36.64880,  24.40960,  17.39900,   4.21665,  13.28870,   0.46515,   3.08997,
  13.43460,  88.48340,  36.78810,  24.77360,  17.89190,   4.23284,  13.27540,
   0.45102,   3.04619,  12.89460,  86.00300,  36.91850,  25.19950,  18.33170,
   4.24391,  13.26740,   0.43753,   3.00775,  12.40440,  83.78810);
var
   j,rang                      : integer;
   elemi,elemj                 : string[4];
 begin

 ier:=0;

  // numro de l'lment dans le tableau
  elemi:=element[no_element];
  elemi:=trim(elemi);
  rang:=0;
  for j:=1 to 213 do begin
    elemj:=elem_crom[j];
    elemj:=uppercase(elemj);
    elemj:=trim(elemj);
    if (elemi = elemj)then begin
      rang:=j;
      break;
    end;
  end;
  if (rang = 0)then begin
    ier:=1;
    exit;
  end;

  //Dtermination des coefficients de Cromer
  j:=(rang-1)*9 ;
  af[no_element,1]:=tab_crom[j+1];
  af[no_element,2]:=tab_crom[j+2];
  af[no_element,3]:=tab_crom[j+3];
  af[no_element,4]:=tab_crom[j+4];
  cf[no_element]:=tab_crom[j+5];
  bf[no_element,1]:=tab_crom[j+6];
  bf[no_element,2]:=tab_crom[j+7];
  bf[no_element,3]:=tab_crom[j+8];
  bf[no_element,4]:=tab_crom[j+9];
end;

procedure efface_stringgrid2;
//--------------------------
var
  i,j                : integer;
  s,s2               : string;
begin
   with fmain.stringGrid2 do begin
     for I := 0 to ColCount - 1 do
     for J:= 0 to RowCount - 1 do  Cells[I,J] := '';
   end;
   if (nb_element > 0)then begin
     with fmain.stringGrid2 do begin
       for i:=1 to nb_element do begin
         s:=copy(element[i],1,2);
         s2:=lowercase(s);
         s2[1]:=s[1];
         cells[0,i+1]:=s2;
       end;
     end;
   end;
end;

procedure lit_stringgrid2;
//------------------------
var
  i,j,ier            : integer;
  s                  : string;
  x                  : real;
begin
   with Fmain.StringGrid2 do begin
     for i:=1 to nb_element do begin
       j:=i;
       //facteurs de Cromer
       licromer(j,ier);
       if(ier = 1)then begin
         beep;
         erreur('element[i] not found?');
         exit;
       end;
       //facteurs de dif. anomaux
       for j:=1 to nb_wl_impur do begin
         s:=cells[2*(j-1)+1,i+1];
         val(s,x,ier);
         delfr[j,i]:=x;
         s:=cells[2*(j-1)+2,i+1];
         val(s,x,ier);
         delfi[j,i]:=x;
       end;
     end;
   end;
end;

procedure ecrit_stringGrid2;
//--------------------------
var
  i,j                : integer;
  s,s2               : string;
begin
   with Fmain.StringGrid2 do begin
     colcount:=5;
     if (2*nb_wl_impur+1 > 5)then colcount:=2*nb_wl_impur+1;
     for I := 0 to ColCount - 1 do
     for J:= 1 to RowCount - 1 do  Cells[I,J] := '';
     cells[0,1]:='Elem.';
     for i:=1 to nb_wl_impur do begin
       str(wl_impur[i]:7:4,s);
       cells[(i-1)*2+1,0]:=s;
       cells[(i-1)*2+2,0]:=s;
       cells[(i-1)*2+1,1]:='f ''';
       cells[(i-1)*2+2,1]:='f "';
     end;
     cells[0,1]:='Elem.';

     for i:=1 to nb_element do begin
       s:=copy(element[i],1,2);
       s2:=lowercase(s);
       s2[1]:=s[1];
       cells[0,i+1]:=s2;
       for j:=1 to nb_wl_impur do begin
         str(delfr[j,i]:6:3,s);
         cells[2*(j-1)+1,i+1]:=s;
         str(delfi[j,i]:6:3,s);
         cells[2*(j-1)+2,i+1]:=s;
       end;
     end;
     refresh;
   end;
end;

procedure reset_fichier_cry;
//--------------------------
begin
  with fmain do begin
    nom_fichier_cry:='';
    fmain.panel4.caption:='Data';
  end;
end;

procedure implemente_fichier_cry;
//-------------------------------
var
  s : string;
begin
  with fmain do begin
    s:=extractFileName(nom_fichier_cry);
    s:=copy(s,1,pos('.',s)-1);
    panel4.caption:='Data'+' ('+extractFileName(nom_fichier_cry)+')';
  end;
end;

procedure reset_fichier_raw;
//--------------------------
begin
  with fmain do begin
    nom_fichier_raw:='';
  end;
end;

procedure implemente_fichier_raw;
//-------------------------------
var
  s : string;
begin
  with fmain do begin
    s:=extractFileName(nom_fichier_raw);
    s:=copy(s,1,pos('.',s)-1);
  end;
end;

{vnement onExit thlim}
procedure Tfmain.rase_resultats(Sender: TObject);{
----------------------------------------------------}
begin
  listbox3.clear;
end;

procedure rase_coord;{
---------------------}
var
  i,j  :integer;
begin
  with fmain.StringGrid1 do begin
    for I := 0 to ColCount - 1 do
      for J:= 1 to RowCount - 1 do
        Cells[I,J] := '';
  end;
  with fmain.StringGrid4 do begin
    for I := 0 to ColCount - 1 do
      for J:= 1 to RowCount - 1 do
        Cells[I,J] := '';
  end;
  with fmain.StringGrid2 do begin
    for I := 0 to ColCount - 1 do
      for J:= 1 to RowCount - 1 do
        Cells[I,J] := '';
  end;
end;
