
unit plecran;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, math, ExtCtrls, ComCtrls, Menus,  clipbrd, Buttons, ExtDlgs;

type
  Tfplecran = class(TForm)
    Panel2: TPanel;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    Echelle1: TMenuItem;
    ImpressionDiagramme1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BitBtn1: TBitBtn;
    Image1: TImage;
    File1: TMenuItem;
    Diagramimportation1: TMenuItem;
    N1: TMenuItem;
    Diagramexportation1: TMenuItem;
    RawformatSiemens1: TMenuItem;
    SimformatCELREF1: TMenuItem;
    RietVeldformatdat1: TMenuItem;
    CPIformatcpi1: TMenuItem;
    CELREFformatsim1: TMenuItem;
    Edit3: TEdit;
    Help1: TMenuItem;
    Philipsformatrd1: TMenuItem;
    Saveimage1: TMenuItem;
    Erase1: TMenuItem;
    Calculateddiagram1: TMenuItem;
    Observeddiagrams1: TMenuItem;
    Difference1: TMenuItem;
    CPIformatcpi2: TMenuItem;
    Poudrixformatcpd1: TMenuItem;
    CPDformatcpd1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    Linear1: TMenuItem;
    Logarithmic1: TMenuItem;
    Squareroot1: TMenuItem;
    procedure dessine(Sender: TObject);
    procedure Modif_echelle(Sender: TObject);
    procedure change_echelle(Sender: TObject; var AllowChange: Boolean);
    procedure shifte_diagramme(Sender: TObject; var AllowChange: Boolean);
    procedure ONMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure initialise(Sender: TObject);
    procedure resize(Sender: TObject);
    procedure reset_diag(Sender: TObject);
    procedure creation(Sender: TObject);
    procedure ImpressionDiagramme1Click(Sender: TObject);
    procedure importe_diag_bruker(Sender: TObject);
    procedure import_diag_sim(Sender: TObject);
    procedure export_diag_sim(Sender: TObject);
    procedure creation_fichier_dif(Sender: TObject);
    procedure OnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1_OnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure importe_diagramme_rietfeld(Sender: TObject);
    procedure import_fichier_cpi(Sender: TObject);
    procedure Aide(Sender: TObject);
    procedure importe_diagramme_philips(Sender: TObject);
    procedure sauve_image(Sender: TObject);
    procedure efface_diagrammes_raw(Sender: TObject);
    procedure efface_diagramme_calcule(Sender: TObject);
    procedure disp_difference(Sender: TObject);
    procedure ecrit_cpi(Sender: TObject);
    procedure ecrit_cpd(Sender: TObject);
    procedure import_fichier_cpd(Sender: TObject);
    procedure Linear1Click(Sender: TObject);
    procedure Logarithmic1Click(Sender: TObject);
    procedure Squareroot1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
var
  fplecran: Tfplecran;
  flag_refresh      : boolean;
  flag_difference   : boolean;
  x_zero            : integer;
procedure cmtopx(xcm,ycm:double; var px,py:integer);
procedure efface_image;
//procedure toto;

implementation

{$R *.DFM}
uses
  print, mathhkl, main, fichiers, difference, lilambda;
type
  tab_car                   = array[1..128]of char;
var
  echx,echy,xmin,xmax                            : double;
  {x_zero,}y_zero,largeur_utile,hauteur_utile    : integer;
  x_up,y_up,x_down,y_down                        : integer;
  souris_down                                    : boolean;
  ixw                                            : integer;
  yy                                             : array[1..1015] of double;

  y_spectre                                      : array[1..2,1..1015]of integer;
  nb_spectre                                     : integer;

  flag_resize                                    : boolean;
  hauteur_depart                                 : integer;

procedure efface_image;{
-----------------------}
begin
  with fplecran do begin
    image1.canvas.brush.color:=clwhite;
    image1.canvas.pen.color:=clblack;
    image1.canvas.Rectangle(0,0,image1.width,image1.height);
  end;
end;

procedure cmtopx(xcm,ycm:double; var px,py:integer);{
--------------------------------------------------}
begin
  px:=round(x_zero+(xcm-xmin)*echx);
  py:=round(hauteur_utile-ycm*echy );
end;

procedure pxtocm(px,py:integer; var xcm,ycm:double);{
--------------------------------------------------}
begin
  xcm:=(px-x_zero)/echx+xmin;
  ycm:=(hauteur_utile-py)/echy;
end;

procedure tras(x,y: double; i :integer);{
--------------------------------------}
var
  ix,iy  : integer;
begin
  cmtopx(x,y,ix,iy);
  if (i = 1) then begin
     fplecran.image1.canvas.lineto(ix,iy);
  end;
  if (i = 0) then begin
     fplecran.image1.canvas.moveto(ix,iy);
  end;
end;

{Trac de l'axe des X}
procedure axex(x1,y1,x2:double);{
--------------------------------}
var
  d,dx,x                                  : double;
  ix,iy,i                                 : integer;
  s                                       : string;
begin
  {Espacement des graduations}
  d:=10;
  dx:=abs(x2-x1);
  if(dx < 0.1)                then d:=0.01;
  if(dx > 0.5) and (dx <= 1)  then d:=0.1;
  if(dx > 1)   and (dx <= 10) then d:=1;
  if(dx > 10)  and (dx <= 50) then d:=5;
  if(dx > 50)  and (dx <= 100)then d:=10;
  if(dx > 100)                then d:=20;

  {Trac des graduations}
   tras(x1,y1,0);
   tras(x2,y1,1);
   i:=round(x1/d);
   dx:=i;
   x:=dx*d;
   if (x < x1) then x:=x+d;
   while (x <= x2) do begin
     tras(x,y1,0);
     cmtopx(x,y1,ix,iy);

     {Quadrillage}
     fplecran.image1.canvas.moveto(ix,iy);
     fplecran.image1.canvas.lineto(ix,iy+5);

     {Si x est suprieur  100, on change de format}
     if (x >= 100) then begin
        str(x:5:1,s);
     end else begin
        str(x:5:1,s);
     end;
     fplecran.image1.canvas.textout(ix-10,iy+5,s);
     x:=x+d;
   end;
end;

{Trac de l'axe des Y}
Procedure axey(x1,y1,y2:double);{
--------------------------------}
var
  s         : string;
  ix,iy     : integer;
begin
  tras(x1,y1,0);
  tras(x1,y2,1);
  case type_echelle of
    0: s:='Intensity';
    1: s:='Log(Intensity)';
    2: S:='SQRT(Intensity)';
  end;
  cmtopx(x1,y2,ix,iy);
  fplecran.image1.canvas.textout(ix+2,iy-5,s);
end;

procedure baton;
//-------------
var
   ix,iy        : integer;
   s               : string;
   x               : double;
begin
  if (nb = 0)then exit;
  with fplecran do begin
    str(nb:2,s);
    x:=raies_tot[nb].dtheta;
    if (fmain.RadioGroup1.ItemIndex = 0)then x:=0.5*x;
    if (fmain.RadioGroup1.ItemIndex = 2)then x:=2*pi/raies_tot[nb].dhkl;
    cmtopx(x,0,ix,iy);
    with image1.canvas do begin
      brush.color:=clyellow;
      TextOut(ix-5,5,s);
      textout(ix-5,hauteur_utile+5,s);
      brush.color:=clwhite;
      pen.color:=clnavy;
      moveto(ix,iy);
      lineto(ix,y_haut+20);
      pen.color:=clblack;
    end;
  end;
end;

procedure dessine_difference;
//----------------------------
var
  i,nbp    : integer;
  xy       : array[1..1015] of tpoint;
begin
  nbp:=0;
  for i:=1 to 1015 do begin
    if (y_spectre[1,i] = -1) or (y_spectre[2,i] = -1)then continue;
    nbp:=nbp+1;
    xy[nbp]:=point(i,100+(y_spectre[2,i]-y_spectre[1,i]));
  end;
  with fdifference.image1.canvas do begin
    brush.color:=$EAEAEA;
    pen.color:=clblack;
    Rectangle(0,0,fdifference.image1.width,fdifference.image1.height);
    moveto(0,100);
    lineto(1015,100);
    polyline(slice(xy,nbp));
  end;
end;

procedure Tfplecran.dessine(Sender: TObject);
//-------------------------------------------
var
   i,j, n,ix,iy,iyw             : integer;
   xx,ech_pro                   : double;
   s,s1                         : string;
   nomf                         : textfile ;
const
  couleur:array[1..10]of integer=(clred,clblue,clfuchsia,clmaroon,clnavy,
  clgreen,clpurple,clolive,cllime,claqua);
begin
   //assignfile(nomf,'espion.txt');
   //rewrite(nomf);
   for i:=1 to 2 do
   for j:=1 to 1015 do y_spectre[i,j]:=-1;
   case fmain.RadioGroup1.ItemIndex of
    0: begin
         xmin:=theta_min/2;
         xmax:=theta_max/2;
       end;
    1: begin
         xmin:=theta_min;
         xmax:=theta_max;
       end;
    2: begin
         xmin:=q_min;
         xmax:=q_max;
       end;
  end;
  if (xmax = 0)then exit;
  edit3.visible:=true;
  modif_donnees:=false;
  image1.canvas.pen.width:=1;
  left:=0;
  x_zero:=10;
  y_zero:=28;
  largeur_utile:=image1.width;
  hauteur_utile:=image1.height-y_zero;
  echx:=(largeur_utile-x_zero)/(xmax-xmin);
  echy:=hauteur_utile*facteur_echelle/100;
  updown1.position:=round((xmax+xmin)/2);

  image1.canvas.pen.color:=clblack;
  image1.refresh;
  image1.canvas.Rectangle(0,0,image1.width,image1.height);
  ixw:=10;
  image1.canvas.font.name:='arial';
  etendue:=xmax-xmin;
  axex(xmin,0,xmax);

  //Trac du diagramme calcul
  if (fmain.radiogroup1.ItemIndex <> 2)then begin
    if (type_echelle = 0)then begin                  //Mise  l'chelle des Y
      ech_pro:=1;
      for i:=1 to nb_pro do yy[i]:=y_pro[i];
    end else if (type_echelle = 1) then begin
      ech_pro:=100/log10(101);
      for i:=1 to nb_pro do  yy[i]:=log10(y_pro[i]+1)*ech_pro;
    end else if (type_echelle = 2) then begin
      ech_pro:=100/sqrt(101);
      for i:=1 to nb_pro do yy[i]:=sqrt(y_pro[i])*ech_pro;
    end;
  end else begin   //reprsentation en Q
    for i:=1 to nb_raie do begin
       yy[i]:=q_tot[i].int*100/qint_max ;
       if (yy[i] < 1)then yy[i]:=1;
    end;
    if (type_echelle = 1) then begin
      ech_pro:=100/log10(101);
      for i:=1 to nb_raie do  yy[i]:=log10(yy[i])*ech_pro;
    end else if (type_echelle = 2) then begin
      ech_pro:=100/sqrt(101);
      for i:=1 to nb_raie do yy[i]:=sqrt(yy[i])*ech_pro;
    end;
  end;

  nb_spectre:=0;
  iyw:=20;
  if (nb_pro > 0)then begin
    case type_echelle of
      0: s:='Intensity';
      1: s:='Log(Intensity)';
      2: s:='Sqrt(Intensity)';
    end;
    image1.canvas.textout(2,3,s);
    case fmain.RadioGroup1.ItemIndex of
      0: s:='Theta';
      1: s:='2Theta';
      2: s:='Q=4pisin(T)/lambda';
    end;
    image1.canvas.textout(image1.width-90,image1.height-20,s);

    //Trac du spectre calcul
    //------------------------
    image1.canvas.textout(2,iyw,'Calculated');
    image1.canvas.font.color:=clblack;
    case fmain.RadioGroup1.ItemIndex of
      0: begin
           tras(0.5*x_pro[1],yy[1],0);
           for i:=2 to nb_pro do tras(0.5*x_pro[i],yy[i],1);
         end;
      1: begin
           tras(x_pro[1],yy[1],0);
           for i:=2 to nb_pro do tras(x_pro[i],yy[i],1);
         end;
      2: begin
           image1.canvas.pen.width:=3;
           for i:=1 to nb_raie do begin
             tras(q_tot[i].q,0,0);
             tras(q_tot[i].q,yy[i],1)
           end;
           image1.canvas.pen.width:=1;
         end;
    end;
    image1.canvas.pen.color:=clblack;
    if (fmain.RadioGroup1.ItemIndex <> 2) then begin
      nb_spectre:=nb_spectre+1;
      if (nb_spectre < 3)then begin
        for i:=1 to nb_pro do begin
          cmtopx(x_pro[i],yy[i],ix,iy);
          if(ix < 0) or (ix > 1015)then continue;
          y_spectre[nb_spectre,ix]:=iy;
          //writeln(nomf,i:5,x_pro[i]:10:3,yy[i]:10:3,ix:5,iy:5)
        end;
        //writeln(nomf,'nb_pro:=',nb_pro:5);
      end;
    end;
  end;

  //Trac des diagrammes observs
  //-----------------------------
  if (nbraw_pro > 0)then begin
   (* assignfile(nomf,'espion');
    rewrite(nomf);
    writeln(nomf,'theta min/max:',theta_min:7:2,theta_max:7:2,' Qmin/max:',q_min:7:2,q_max:7:2);
    writeln(nomf,'echellex:',echx:8:3,' xmax/xmin: ',xmax:8:2,xmin:8:2); *)
    for j:=1 to nbraw_pro do begin      //nb_raw_pro : nb de fichiers exp.
      nb_spectre:=nb_spectre+1;
      iyw:=iyw+15;

      image1.canvas.pen.color:=couleur[j];
      s:=extractFilename(nom_raw[j]);
      str(lambda_fichier_raw[j]:8:5,s1);
      s1:=' ('+s1+' )';
      s:=s+s1;

      image1.canvas.font.color:=couleur[j];
      image1.canvas.textout(2,iyw,s);

      for i:=1 to 1015 do begin
        case type_echelle of
          0: yy[i]:=yraw_pro[j,i];
          1: yy[i]:=log10(yraw_pro[j,i]+1);
          2: yy[i]:=sqrt(yraw_pro[j,i]);
        end;
      end;
      ymax:=0;
      for i:=1 to 1015 do  if (yy[i] > ymax)then ymax:=yy[i];
      ech_pro:=100/ymax;
      for i:=1 to 1015 do yy[i]:=yy[i]*ech_pro;
      n:=0;
      for i:=1 to 1015 do begin
//Modif du 25/02/2000-----------------------------------------------------------
  //if (xraw_pro[j,i] < theta_min) or (xraw_pro[j,i] > theta_max)then continue;
//------------------------------------------------------------------------------
        case fmain.RadioGroup1.ItemIndex of
           1: xx:=xraw_pro[j,i];
           0: xx:=0.5*xraw_pro[j,i];
           2: xx:=qraw_pro[j,i];
        end;
//Modif du 25/02/2000-----------------------------------------------------------
        case fmain.RadioGroup1.ItemIndex of
           0,1: if (xx < theta_min) or (xx > theta_max)then continue;
           2:  if (xx < q_min) or (xx > q_max)then continue;
        end;
//------------------------------------------------------------------------------
        if (nb_spectre < 3)then begin
          case fmain.radiogroup1.ItemIndex of
            1: cmtopx(xraw_pro[j,i],yy[i],ix,iy);
            0: cmtopx(0.5*xraw_pro[j,i],yy[i],ix,iy);
            2: cmtopx(qraw_pro[j,i],yy[i],ix,iy);
          end;
          if (ix < 1) or (ix > 1015) then continue;
          y_spectre[nb_spectre,ix]:=iy;
          //writeln(nomf,i:5,xx:10:3,yy[i]:10:3,ix:5,iy:5);
        end;
        if (n = 0)then tras(xx,yy[i],0) else tras(xx,yy[i],1);
        n:=n+1;
      end;
      image1.canvas.pen.color:=clblack;
      image1.canvas.font.color:=clblack;
    end;
    //writeln(nomf,'nbraw_pro=',nbraw_pro:5);
    //closefile(nomf);
  end;
  if flag_difference then dessine_difference;
  baton;
  flag_refresh:=false;
  clipboard.assign(fplecran.image1.picture);

end;

procedure Tfplecran.Modif_echelle(Sender: TObject);
//-------------------------------------------------
begin
  if (nb_raie = 0) and (nb_raie_raw = 0) then begin
    beep;
    erreur('no calculated diagram!');
    exit;
  end;

//Modif du 25 fvrier 2000----------------------------------------------------
  fplecran.height:=286;
  fplecran.top:=459;
  flag_resize:=false;
  resize(sender);
//-----------------------------------------------------------------------------

//fechelle.visible:=true;
//  fechelle.show;
//  fechelle.setfocus;
end;

procedure Tfplecran.change_echelle(Sender: TObject;
  var AllowChange: Boolean);
//-----------------------------------------------
begin
 if (UpDown2.position = UpDown2.max) then begin
   { music;}
     beep;
     exit;
  end;
  facteur_echelle:=UpDown2.position/10;
  flag_refresh:=true;
  dessine(sender);
end;

procedure Tfplecran.shifte_diagramme(Sender: TObject;
  var AllowChange: Boolean);
//---------------------------------------------------
var
  position_lue             : integer;
begin
  position_lue:=UpDown1.position;
  theta_min:=position_lue-0.5*etendue;
  theta_max:=position_lue+0.5*etendue;
  flag_refresh:=true;
  dessine(sender);
end;

procedure Tfplecran.reset_diag(Sender: TObject);
//----------------------------------------------
begin
  flag_refresh:=true;
  theta_min:=theta_min_depart;
  theta_max:=theta_max_depart;
  q_min:=q_min_depart;
  q_max:=q_max_depart;
  facteur_echelle:=1;
  dessine(sender);
end;

procedure Tfplecran.resize(Sender: TObject);
//------------------------------------------
begin
  clipboard.clear;
  if (abs(clientheight-hauteur_depart) > 50)then begin
    flag_resize:=true;
    initialise(sender);
    image1.refresh;
  end else begin
    flag_resize:=false;
  end;
  if flag_difference then fdifference.initialise(sender);
  dessine(sender);
end;

procedure Tfplecran.initialise(Sender: TObject);
//----------------------------------------------
begin
  left:=fmain.left;
  //top:=fmain.height+1;
  width:=fmain.width;

  image1.top:=0;
  image1.left:=0;
  image1.width:=ClientWidth;
  image1.height:=ClientHeight-panel2.height-1;

  panel2.top:=clientheight-panel2.height;
  panel2.left:=0;
  panel2.width:=clientwidth;

  hauteur_depart:=height;
  facteur_echelle:=1;
  theta_min:=theta_min_depart;
  theta_max:=theta_max_depart;
  q_min:=q_min_depart;
  q_max:=q_max_depart;
  if(modif_donnees = true)then dessine(sender);
end;

procedure Tfplecran.creation(Sender: TObject);
//--------------------------------------------
begin
  edit3.text:='Click on a peak to index it, or click on a line of the list.'+
  '   Click and drag a box to "zoom".  Click on the right button to "unzoom".';
  modif_donnees:=false;
  clipboard.clear;

  left:=fmain.left;
  width:=fmain.width;
  top:=fmain.height+1;
  height:=748;
  image1.height:=ClientHeight-panel2.height-1;
  flag_resize:=false;
  flag_refresh:=false;
  linear1.checked:=true;
  logarithmic1.checked:=false;
  squareroot1.checked:=false;
end;

procedure Tfplecran.ImpressionDiagramme1Click(Sender: TObject);
//------------------------------------------------------------
begin
  if (nb_raie = 0) and (nb_fichier_raw = 0) then begin
    beep;
    erreur('No calculated diagram!');
    exit;
  end;
  fprint.visible:=true;
end;

procedure chaine_to_car(var s: string; var caracteres: tab_car; nb: integer);
//--------------------------------------------------------------------------
var
  i,l          : integer;
begin
  for i:=1 to 128 do caracteres[i]:=' ';
  if (length(s) < nb) then l:=length(s) else l:=nb;
  for i:=1 to l do caracteres[i]:=s[i];
end;

procedure Tfplecran.export_diag_sim(Sender: TObject);
//----------------------------------------------------
var
  s                   : string;
  nomf                : File;
  tab                 : tab_car;
  i2                  : integer;
  i                   : integer;
  r4                  : single;
  r8                  : double;
  wo                  : word;

begin
   if(nb_pro = 0)then begin
     beep;
     erreur('No calculated diagram!');
     exit;
   end;

   SaveDialog1.filterIndex:=1;
   if SaveDialog1.execute then s:=SaveDialog1.filename;
   if (length(s) > 0) then begin
     if (pos('.sim',s) = 0)then s:=s+'.sim';

     if FileExists(s) then begin
        beep;
        wo:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (wo = mrNo) or (wo = mrAbort) then exit;
     end;

     assignFile(nomf,s);
     rewrite(nomf,1);

// Header fichier
     // Mot cl
     s:='RAW2';
     chaine_to_car(s,tab,4);
     blockwrite(nomf,tab,4);
     // Nombre de tranches
     i2:=1;
     blockwrite(nomf,i2,2);
     // "spare reserved" + Nom de base de l'chantillon
     s:='  '+titre;
     chaine_to_car(s,tab,34);
     blockwrite(nomf,tab,34);
     // Commentaires
     s:='Fichier provenant de POUDRIX';
     chaine_to_car(s,tab,128);
     blockwrite(nomf,tab,128);
     // Date
     s:=DateToStr(date);
     chaine_to_car(s,tab,20);
     blockwrite(nomf,tab,20);
     // symbole de l'anode
     s:= 'Cu';
     chaine_to_car(s,tab,2);
     blockwrite(nomf,tab,2);
     //Lambda1,lambda2,intensity ratio
     r4:=lambda;
     blockwrite(nomf,r4,4);
     r4:=0;
     blockwrite(nomf,r4,4);
     r4:=0;
     blockwrite(nomf,r4,4);
     // Code diffractometre et mot de configuration
     i2:=0;
     blockwrite(nomf,i2,2);
     i2:=0;
     blockwrite(nomf,i2,2);
     // lambda3
     r4:=1.39;
     blockwrite(nomf,r4,4);
     // Temps total en secondes
     r4:=1000;
     blockwrite(nomf,r4,4);
     // Date/temps au format Lotus
     r8:=0;
     blockwrite(nomf,r8,8);
     // 34 bytes libres pour expansion
     s:='';
     chaine_to_car(s,tab,34);
     blockwrite(nomf,tab,34);

// header tranche
     // Nbre total de bytes dans le header de tranche
     i2:=60;
     blockwrite(nomf,i2,2);

     // step_count pour la tranche
     i2:=nb_pro;
     blockwrite(nomf,i2,2);

     // Identificateur de mode de couplage
     i2:=10;
     blockwrite(nomf,i2,2);

     // Mode pas  pas
     i2:=0;
     blockwrite(nomf,i2,2);

     // Temps de comptage (step_time)
     r4:=1;
     blockwrite(nomf,r4,4);

     // Pas (step_size)
     r4:=pas;
     blockwrite(nomf,r4,4);

     // Angles de dpart
     r4:=theta_min;
     blockwrite(nomf,r4,4);
     r4:=theta_min/2;
     blockwrite(nomf,r4,4);
     r4:=0;for i:=1 to 4 do blockwrite(nomf,r4,4);

     // addr 40  48
     i2:=0;
     for i:=1 to 5 do blockwrite(nomf,i2,2);

     //  ddr 50  54
     r4:=0;
     for i:=1 to 2 do blockwrite(nomf,r4,4);

     // addr 58  60
     i2:=0;
     blockwrite(nomf,i2,2);

// Donnes diagramme
     for i:=1 to nb_pro do begin
       r4:=10*y_pro[i];
       blockwrite(nomf,r4,4);
     end;

     closeFile(nomf);
     //filelistbox1.update;
   end;
end;

procedure Tfplecran.creation_fichier_dif(Sender: TObject);
//------------------------------------------------------
var
   s                                   : string;
   nomf                                : File;

  i,j                                  : integer;
  i2                                   : smallint;
  c4                                   : array[1..4]of char;
  c                                    : char;
  x                                    : single;
  wo                                   : word;
begin
   SaveDialog1.filterIndex:=2;
   if SaveDialog1.execute then s:=SaveDialog1.filename;
   if (length(s) > 0) then begin
     if (pos('.dif',s) = 0)then s:=s+'.dif';

     if FileExists(s) then begin
        beep;
        wo:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (wo = mrNo) or (wo = mrAbort) then exit;
     end;

     assignFile(nomf,s);
     rewrite(nomf,1);
     s:='DIF2';
     for i:=1 to 4 do c4[i]:=s[i];
     blockwrite(nomf,c4,4);
     {nr}
     i2:=1;
     blockwrite(nomf,i2,2);
     c:=' ';
     for i:=1 to 184 do blockwrite(nomf,c,1);
     {longueur d'onde}
     x:=lambda;
     blockwrite(nomf,x,4);
     {lambda2}
     blockwrite(nomf,x,4);
     {ratio}
      x:=1;
      blockwrite(nomf,x,4);
      for i:=1 to 54 do blockwrite(nomf,c,1);
      {dimension du header}
      i2:=96;
      blockwrite(nomf,i2,2);
      for i:=1 to 4 do blockwrite(nomf,c,1);
      {nb. de pics}
      i2:=nb_raie;
      blockwrite(nomf,i2,2);
      for i:=1 to 10 do blockwrite(nomf,c,1);
      {step_size}
      x:=0;
      blockwrite(nomf,x,4);
      {2 thta de dpart}
      x:=theta_min;
      blockwrite(nomf,x,4);
      //Ecriture thta et intensit
      for i:=1 to 70 do blockwrite(nomf,c,1);
      for i:=1 to nb_raie do begin
        x:=raies_tot[i].dtheta;
        blockwrite(nomf,x,4);
        x:=raies_tot[i].int;
        blockwrite(nomf,x,4);
        for j:=1 to 8 do blockwrite(nomf,c,1);
      end;
      closefile(nomf);
    end;

end;

procedure Tfplecran.OnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//-------------------------------------------------------------------
begin
  souris_down:=true;
  x_down:=x;
  y_down:=y;
end;

procedure Tfplecran.ONMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//--------------------------------------------------------------------
var
 xx,xcm1,ycm1,xcm2,ycm2              : double;
 i,ix,iy,dif                         : integer;
 s                                   : string;
begin
  x_up:=x;
  y_up:=y;
  //effacement du zoom
  if (button = mbright)then begin
    souris_down:=false;
    reset_diag(sender);
    exit;
  end;
  //Identification d'une raie
  if (abs(x_up-x_down) < 3)then begin
    nb:=0;
    flag_refresh:=true;
    dessine(sender);
    for i:=1 to nb_raie_tot do begin
      xx:=raies_tot[i].dtheta;
      if (fmain.RadioGroup1.ItemIndex = 0)then xx:=0.5*xx;
      cmtopx(xx,0,ix,iy);
      if (abs(ix-x) < 4)then begin
           fmain.listbox3.itemIndex:=i+1;
           str(i:2,s);
           image1.canvas.brush.color:=clyellow;
           image1.canvas.TextOut(ix-5,y_haut+5,s);
           image1.canvas.brush.color:=clwhite;
           image1.canvas.pen.color:=clnavy;
           image1.canvas.moveto(ix,iy);
           image1.canvas.lineto(ix,y_haut+20);
           image1.canvas.pen.color:=clblack;
       end;
    end;
  end else begin
  //Zoom
    if (souris_down) then begin
      pxtocm(x_down,y,xcm1,ycm1);
      pxtocm(x,y,xcm2,ycm2);
      case fmain.radiogroup1.ItemIndex of
        0: begin
             theta_min:=2*xcm1;
             theta_max:=2*xcm2;
             q_min:=4*pi*sin(theta_min/114.5914)/lambda_max;
             q_max:=4*pi*sin(theta_max/114.5914)/lambda_min;
           end;
        1: begin
             theta_min:=xcm1;
             theta_max:=xcm2;
             q_min:=4*pi*sin(theta_min/114.5914)/lambda_max;
             q_max:=4*pi*sin(theta_max/114.5914)/lambda_min;
           end;
        2: begin
             q_min:=xcm1;
             q_max:=xcm2;
             theta_min:=2*57.2957*arcsin(q_min*lambda_max/(4*pi));
             theta_max:=2*57.2957*arcsin(q_max*lambda_min/(4*pi));
           end;
      end;
      dif:=image1.height-y_zero-y_down;
      if (dif < 10)then dif:=10;
      facteur_echelle:=
      facteur_echelle*(image1.height-y_zero)/(image1.height-y_down-y_zero);
      updown2.position:=round(10*facteur_echelle);
      etendue:=theta_max-theta_min;
      dessine(sender);
    end;
  end;
  souris_down:=false;
end;

procedure Tfplecran.Image1_OnMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
//--------------------------------------------------------------------------
var
  xcm,ycm,d                                 : double;
  s,s1                                      : string;
begin
  if(nb_pro = 0)and (nb_raie_raw = 0) then exit;
  pxtocm(x,y,xcm,ycm);
  str(xcm:8:2,s1);
  case fmain.RadioGroup1.ItemIndex of
    0: s:='Th=';
    1: s:='2Th=';
    2: s:='Q=';
  end;
  s:=s+s1;
  case fmain.RadioGroup1.ItemIndex of
    0: d:=lambda/(2*sin(xcm/57.2957));
    1: d:=lambda/(2*sin(xcm/114.592));
    2: d:=2*pi/xcm;
  end;
  str(d:7:3,s1);
  s1:='  d='+s1;
  if (nb_wl_impur > 1)and (fmain.RadioGroup1.ItemIndex <> 2)then s1:='';
  s:=s+s1;
  edit1.text:=s;

  //edit6.text:=inttostr(x)+' '+inttostr(y);
  if souris_down and (abs(x-x_down) > 3)then begin
    image1.picture.assign(clipboard);
    image1.canvas.pen.color:=clgreen;
    with image1.canvas do begin
      moveto(x_down,y_down);
      lineto(x,y_down);
      lineto(x,y);
      lineto(x_down,y);
      lineto(x_down,y_down);
    end;
    image1.canvas.pen.color:=clblack;
    image1.refresh;
  end;

end;

procedure Tfplecran.Aide(Sender: TObject);
//---------------------------------------
begin
   chdir(repertoire_origine);
   Application.HelpFile:='poudrix.hlp';
   Application.HelpContext(3);
end;

//==============================Lecture fichier profil==========================

//Diagrammes Brucker/Siemens (*.raw)
procedure Tfplecran.importe_diag_bruker(Sender: TObject);
//----------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(1,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;

//Philips
procedure Tfplecran.importe_diagramme_philips(Sender: TObject);
//-------------------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(2,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;

//Diagrammes simuls (*.sim) CELREF
procedure Tfplecran.import_diag_sim(Sender: TObject);
//---------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(3,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;

//Diagrammes Rietveld (*.dat)
procedure Tfplecran.importe_diagramme_rietfeld(Sender: TObject);
//-------------------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(4,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;

//Fichiers CPI (*.cpi)
procedure Tfplecran.import_fichier_cpi(Sender: TObject);
//-----------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(5,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;

procedure Tfplecran.import_fichier_cpd(Sender: TObject);
//-----------------------------------------------------
var ier:integer;
begin
  lit_fichier_raw(6,ier);
  if(ier = 1)then exit;
  dessine(sender);
end;
procedure Tfplecran.sauve_image(Sender: TObject);
//----------------------------------------------
var
  s         : string;
begin
   if SavePictureDialog1.execute then begin
      s:=SavePictureDialog1.filename;
      if (pos('.',s) = 0) then begin
        (*if (SavePictureDialog1.filterindex = 1)then s:=s+'.jpg';
        if (SavePictureDialog1.filterindex = 2)then s:=s+'.bmp';*)
        s:=s+'.bmp';
      end;
      image1.picture.savetofile(s);
      erreur('The picture was save in the '+s+' file');
   end;
   (*savedialog1.filterindex:=3;
   if SaveDialog1.execute then begin
     s:=SaveDialog1.filename;
     if (pos('.',s) = 0) then s:=s+'.bmp';
     image1.picture.savetofile(s);
     erreur('The picture was save in the '+s+' file');
   end;*)
end;

procedure Tfplecran.efface_diagrammes_raw(Sender: TObject);
//---------------------------------------------------------
begin
  nbraw_pro:=0;
  nb_fichier_raw:=0;
  flag_difference:=false;
  difference1.checked:=false;
  fdifference.visible:=false;
  dessine(sender);
end;

procedure Tfplecran.efface_diagramme_calcule(Sender: TObject);
//------------------------------------------------------------
begin
  nb_pro:=0;
  nb_proN:=0;
  flag_difference:=false;
  fdifference.visible:=false;
  difference1.checked:=false;
  dessine(sender);
end;

procedure Tfplecran.disp_difference(Sender: TObject);
//---------------------------------------------------
begin
 if (nb_spectre < 2)then exit;
 if flag_difference then begin
    flag_difference := false;
    fdifference.visible:=false;
    difference1.checked:=false;
    exit;
  end else begin
    flag_difference:=true;
    fdifference.visible:=true;
    difference1.checked:=true;
    dessine(sender);
  end;
end;

procedure Tfplecran.ecrit_cpi(Sender: TObject);
//--------------------------------------------
var
  nomf            : textFile;
  i,j             : integer;
  pas             : double;
  s               : string;
  wo              : word;
begin
  if(nb_pro = 0)then begin
     beep;
     erreur('No calculated diagram!');
     exit;
  end;
  if (nb_wl_impur > 1)then
  erreur('Warning! The diagram was calculated with '+inttostr(nb_wl_impur)+
    ' Wavelengths');
  SaveDialog1.filterIndex:=4;
  if SaveDialog1.execute then s:=SaveDialog1.filename;
  if (length(s) > 0) then begin
     if (pos('.cpi',s) = 0)then s:=s+'.cpi';

     if FileExists(s) then begin
        beep;
        wo:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (wo = mrNo) or (wo = mrAbort) then exit;
     end;

     assignFile(nomf,s);
     rewrite(nomf);
     writeln(nomf,'SIETRONICS XRD SCAN');
     //On cadre  gauche
     str(theta_min:7:3,s);               //theta min
     s:=trimleft(s);
     writeln(nomf,s);
     str(theta_max:7:3,s);               //theta  max
     s:=trimleft(s);
     writeln(nomf,s);
     str((x_pro[2]-x_pro[1]):7:4,s);     //pas
     s:=trimleft(s);
     writeln(nomf,s);
                                         //Anode
     if (anode_calc <> '')then writeln(nomf,anode_calc) else writeln(nomf,'Xx');
     str(wl_impur[1]:8:5,s);             //lambda
     s:=trimleft(s);
     writeln(nomf,s);
     writeln(nomf,datetostr(Date));      // Date
     writeln(nomf,'1');                  //'1'
     writeln(nomf,'SampleIdent '+titre); //SampleIdent
     writeln(nomf,'SCANDATA');           //Scandata
     for i:=1 to nb_pro do begin
       str(1000*y_pro[i]:10:0,s);
       s:=trimleft(s);
       writeln(nomf,s);
     end;
     closeFile(nomf);
  end;
end;

//Format Poudrix imit de CPI (Cranswick 10-9-90)
procedure Tfplecran.ecrit_cpd(Sender: TObject);
//--------------------------------------------
var
  nomf            : textFile;
  i,j             : integer;
  pas,cc,ll       : double;
  s,s1            : string;
  c,l             : array[1..4] of double;
  wo              : word;
begin
  if(nb_pro = 0)then begin
     beep;
     erreur('No calculated diagram!');
     exit;
  end;

  // Si WL multiple ranger par pcent croissant
  for i:=1 to 4 do begin
    c[i]:=0;
    l[i]:=0;
  end;
  for i:=1 to nb_wl_impur do begin
    l[i]:=wl_impur[i];
    c[i]:=pcent_impur[i];
  end;
  if (nb_wl_impur > 1)then begin
    for i:=1 to nb_wl_impur-1 do begin
      for j:=i+1 to nb_wl_impur do begin
        if (c[i] < c[j])then begin
          cc:=c[i];
          c[i]:=c[j];
          c[j]:=cc;
          ll:=l[i];
          l[i]:=l[j];
          l[j]:=ll;
        end;
      end;
    end;
  end;

  SaveDialog1.filterIndex:=5;
  if SaveDialog1.execute then s:=SaveDialog1.filename;
  if (length(s) > 0) then begin
     if (pos('.cpd',s) = 0)then s:=s+'.cpd';

     if FileExists(s) then begin
        beep;
        wo:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (wo = mrNo) or (wo = mrAbort) then exit;
     end;

     assignFile(nomf,s);
     rewrite(nomf);
     writeln(nomf,'SIETRONICS XRD SCAN');
     str(theta_min:7:3,s);
     s:=trimleft(s);
     writeln(nomf,s);
     str(theta_max:7:3,s);
     s:=trimleft(s);
     writeln(nomf,s);
     str((x_pro[2]-x_pro[1]):7:4,s);
     s:=trimleft(s);
     writeln(nomf,s);
     if (nb_wl_impur > 1)then writeln(nomf,'Xx') else begin
        if (anode_calc <> '')then writeln(nomf,anode_calc) else writeln(nomf,'Xx') ;
     end;
     s:='';
     for i:=1 to nb_wl_impur do begin
       str(l[i]:8:5,s1);
       s:=s+s1;
       str(c[i]:6:3,s1);
       s:=s+s1;
     end;
     s:=trimleft(s);
     writeln(nomf,s);
     writeln(nomf,datetostr(Date));
     writeln(nomf,'1');
     writeln(nomf,'SampleIdent '+titre);
     writeln(nomf,'SCANDATA');
     for i:=1 to nb_pro do begin
       str(1000*y_pro[i]:10:0,s);
       s:=trimleft(s);
       writeln(nomf,s);
     end;
     closeFile(nomf);
  end;
end;

procedure Tfplecran.Linear1Click(Sender: TObject);
//------------------------------------------------
begin
  linear1.checked:=true;
  logarithmic1.checked:=false;
  squareroot1.checked:=false;
  type_echelle:=0;
  if (nb_raie > 0)then begin
//Modif du 25 fvrier 2000----------------------------------------------------
  fplecran.height:=276;
  fplecran.top:=459;
  flag_resize:=false;
  resize(sender);
//-----------------------------------------------------------------------------
    modif_donnees:=true;
    dessine(sender);
  end;
end;

procedure Tfplecran.Logarithmic1Click(Sender: TObject);
//------------------------------------------------------
begin
  linear1.checked:=false;
  logarithmic1.checked:=true;
  squareroot1.checked:=false;
  type_echelle:=1;
  if (nb_raie > 0)then begin
//Modif du 25 fvrier 2000----------------------------------------------------
  fplecran.height:=276;
  fplecran.top:=459;
  flag_resize:=false;
  resize(sender);
//-----------------------------------------------------------------------------
    modif_donnees:=true;
    dessine(sender);
  end;
end;

procedure Tfplecran.Squareroot1Click(Sender: TObject);
//----------------------------------------------------
begin
  linear1.checked:=false;
  logarithmic1.checked:=false;
  squareroot1.checked:=true;
  type_echelle:=2;
  if (nb_raie > 0)then begin
    modif_donnees:=true;
    dessine(sender);
//Modif du 25 fvrier 2000----------------------------------------------------
  fplecran.height:=276;
  fplecran.top:=459;
  flag_resize:=false;
  resize(sender);
//-----------------------------------------------------------------------------
  end;

end;

end.
